cordova.define("cordova-plugin-aliyun-rpc.aliyunRpc", function(require, exports, module) {
// eslint-disable-next-line
var exec = require('cordova/exec');

/**
 * window.cordova.plugins.aliyunRpc
 */
function AliyunRpc() {
  /**
   * get metaInfo from alirpc sdk
   *
   * @param successCallback
   *  successCallback arguments:
   *    1. metaInfo {Object}: metaInfo from alirpc init method
   *      1). apdidToken {String}
   *      2). appName {String}
   *      3). appVersion {String}
   *      4). bioMetaInfo {String}
   *      5). deviceModel {String}
   *      6). deviceType {String}
   *      7). osVersion {String}
   *      8). zimVer {String}
   * @param errorCallback
   *  errorCallback arguments:
   *    1. message{String}: error message
   * @return
   */
  this.init = function (successCallback, errorCallback) {
    exec(successCallback, errorCallback, 'AliyunRpc', 'init');
  };
  /**
   * call alirpc sdk for face recognition
   *
   * @param successCallback
   *    successCallback arguments
   *      1. response {Object}: get from alirpc verify method
   *        1). reason {String}
   *        2). retCodeSub {String}
   *        3). retMessageSub {String}
   *        4). bizData {String}
   *        5). extInfo {Object}
   *        6). code {number} 1000-success, 1003-exit, 2002-network error, 2006-failed
   *        7). message {String}
   * @param errorCallback
   *  errorCallback arguments:
   *    1. response{Object}: get from alirpc verify method, see successCallback arguments for more information
   * @param options
   *    1. queryId{String}: get from backend with meta info
   */
  this.verify = function (successCallback, errorCallback, options) {
    exec(successCallback, errorCallback, 'AliyunRpc', 'verify', [options || {}]);
  };
  this.getVersion = function (successCallback, errorCallback, options) {
    exec(successCallback, errorCallback, 'AliyunRpc', 'getVersion', [options || {}]);
  };
}

module.exports = new AliyunRpc();

});
