/* **********************************
yata.js version 0.0.12
https://yata.com

copyright HanJe
see README.md and LICENSE for details
********************************** */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
    typeof define === 'function' && define.amd ? define(factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.yata = factory());
}(this, (function () { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    var CONFIG = {
        DEBUG: false,
        LIB_VERSION: '0.0.13'
    };
    var perfCONFIG = {
        // Metrics
        isResourceTiming: false,
        isElementTiming: false,
        // Logging
        maxTime: 30000,
    };

    // 在控制台跑单元测试时，window对象不存在
    var win = window;
    // 将较长的方法名或对象重命名，可以降低打包的包体积
    var ArrayProto = Array.prototype, FuncProto = Function.prototype, ObjectProto = Object.prototype, slice = ArrayProto.slice, toStr = ObjectProto.toString, hasOwnProperty = ObjectProto.hasOwnProperty, windowConsole = win.console;
    var nav = win.navigator;
    var doc = win.document;
    var userAgent = nav.userAgent;
    var wp = win.performance;
    var getDM = function () { return nav.deviceMemory; };
    var getHC = function () { return nav.hardwareConcurrency; };
    var isPerformanceSupported = function () {
        return wp && !!wp.getEntriesByType /*&& !!wp.now*/ && !!wp.mark;
    };
    var nativeBind = FuncProto.bind, nativeForEach = ArrayProto.forEach, nativeIndexOf = ArrayProto.indexOf, nativeMap = ArrayProto.map, nativeIsArray = Array.isArray, breaker = {};
    //TODO: console override
    var console$1 = {
        log: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (CONFIG.DEBUG && !utils.isUndefined(windowConsole) && windowConsole) {
                try {
                    windowConsole.log.apply(windowConsole, args);
                }
                catch (e) {
                    utils.each(args, function (arg) {
                        windowConsole.log(arg);
                    });
                }
            }
        },
        warn: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (CONFIG.DEBUG && !utils.isUndefined(windowConsole) && windowConsole) {
                args = ['Yata warning:'].concat(args);
                try {
                    windowConsole.warn.apply(windowConsole, args);
                }
                catch (e) {
                    utils.each(args, function (arg) {
                        windowConsole.warn(arg);
                    });
                }
            }
        },
        error: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (CONFIG.DEBUG && !utils.isUndefined(windowConsole) && windowConsole) {
                args = ['Yata error:'].concat(args);
                try {
                    windowConsole.error.apply(windowConsole, args);
                }
                catch (e) {
                    utils.each(args, function (arg) {
                        windowConsole.error(arg);
                    });
                }
            }
        },
        critical: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (!utils.isUndefined(windowConsole) && windowConsole && windowConsole.error) {
                args = ['Yata critical:'].concat(args);
                try {
                    windowConsole.error.apply(windowConsole, args);
                }
                catch (e) {
                    utils.each(args, function (arg) {
                        windowConsole.error(arg);
                    });
                }
            }
        }
    };
    var logFuncWithPrefix = function (func, prefix) {
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            args[0] = "[" + prefix + "]" + args[0];
            return func.apply(console$1, args);
        };
    };
    var consoleWithPrefix = function (prefix) {
        return {
            log: logFuncWithPrefix(console$1.log, prefix),
            error: logFuncWithPrefix(console$1.error, prefix),
            critical: logFuncWithPrefix(console$1.critical, prefix)
        };
    };
    // This is to block various web spiders from executing our JS and
    // sending false tracking data
    var BLOCKED_UA_STRINGS = [
        'baiduspider',
        'bingbot',
        'bingpreview',
        'facebookexternal',
        'pinterest',
        'screaming frog',
        'yahoo! slurp',
        'yandexbot',
        // a whole bunch of goog-specific crawlers
        // https://developers.google.com/search/docs/advanced/crawling/overview-google-crawlers
        'adsbot-google',
        'apis-google',
        'duplexweb-google',
        'feedfetcher-google',
        'google favicon',
        'google web preview',
        'google-read-aloud',
        'googlebot',
        'googleweblight',
        'mediapartners-google',
        'storebot-google'
    ];
    // 扩展UNDERSCORE
    var utils = {
        trim: function (str) {
            // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/Trim#Polyfill
            return str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
        },
        isObject: function (obj) {
            return (obj === Object(obj) && !utils.isArray(obj));
        },
        isEmptyObject: function (obj) {
            if (utils.isObject(obj)) {
                for (var key in obj) {
                    if (hasOwnProperty.call(obj, key)) {
                        return false;
                    }
                }
                return true;
            }
            return false;
        },
        isPlainObject: function (obj) {
            return obj && toStr.call(obj) === '[object Object]' && 'isPrototypeOf' in obj;
        },
        isPrimitive: function (obj) {
            return obj !== Object(obj);
        },
        isFunction: function (f) {
            try {
                return /^\s*\bfunction\b/.test(f);
            }
            catch (e) {
                return false;
            }
        },
        isArguments: function (obj) {
            return !!(obj && hasOwnProperty.call(obj, 'callee'));
        },
        isString: function (obj) {
            return toStr.call(obj) === '[object String]';
        },
        isArray: function (obj) {
            if (nativeIsArray) {
                return nativeIsArray(obj);
            }
            return toStr.call(obj) === '[object Array]';
        },
        isDate: function (obj) {
            return toStr.call(obj) === '[object Date]';
        },
        isNumber: function (obj) {
            return toStr.call(obj) === '[object Number]';
        },
        isUndefined: function (obj) {
            return obj === void 0;
        },
        isDOMElement: function (obj) {
            return !!(obj && obj.nodeType === 1);
        },
        isBlockedUA: function (ua) {
            ua = ua.toLowerCase();
            for (var i = 0; i < BLOCKED_UA_STRINGS.length; i++) {
                if (ua.indexOf(BLOCKED_UA_STRINGS[i]) !== -1) {
                    return true;
                }
            }
            return false;
        },
        bind: function (func, context) {
            var args, bound;
            if (nativeBind && func.bind === nativeBind) {
                return func.bind(context);
            }
            if (!utils.isFunction(func)) {
                throw new TypeError();
            }
            args = slice.call(arguments, 2);
            bound = function () {
                if (!(this instanceof bound)) {
                    return func.apply(context, args.concat(slice.call(arguments)));
                }
                var Ctor = function () {
                };
                var self = new Ctor();
                Ctor.prototype = null;
                var result = func.apply(self, args.concat(slice.call(arguments)));
                if (Object(result) === result) {
                    return result;
                }
                return self;
            };
            return bound;
        },
        bindInstanceMethods: function (obj) {
            for (var func in obj) {
                if (hasOwnProperty.call(obj, func) && typeof obj[func] === 'function') {
                    obj[func] = utils.bind(obj[func], obj);
                }
            }
        },
        each: function (obj, iterator, context) {
            if (obj == null) {
                return;
            }
            if (nativeForEach && obj.forEach === nativeForEach) {
                obj.forEach(iterator, context);
            }
            else if (obj.length === +obj.length) {
                for (var i = 0, l = obj.length; i < l; i++) {
                    if (i in obj && iterator.call(context, obj[i], i, obj) === breaker) {
                        return;
                    }
                }
            }
            else {
                for (var key in obj) {
                    if (hasOwnProperty.call(obj, key)) {
                        if (iterator.call(context, obj[key], key, obj) === breaker) {
                            return;
                        }
                    }
                }
            }
        },
        getQueryParam: function (url, param) {
            param = param.replace(/[[]/, '\\[').replace(/[\]]/, '\\]');
            var regexStr = '[\\?&]' + param + '=([^&#]*)';
            var regex = new RegExp(regexStr);
            var results = regex.exec(url);
            if (results == null || (results && typeof results[1] !== 'string' && results[1].length)) {
                return '';
            }
            else {
                var result = results[1];
                try {
                    result = decodeURIComponent(result);
                }
                catch (e) {
                    console$1.error('Skipping decoding for malformed query param: ' + result);
                }
                return result.replace(/\+/g, ' ');
            }
        },
        escapeHTML: function (s) {
            var escaped = s;
            if (escaped && utils.isString(escaped)) {
                escaped = escaped.replace(/&/g, '&amp;')
                    .replace(/</g, '&lt;')
                    .replace(/>/g, '&gt;')
                    .replace(/"/g, '&quot;')
                    .replace(/'/g, '&#039;');
            }
            return escaped;
        },
        //TODO: extend method
        extend: function (obj) {
            var rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                rest[_i - 1] = arguments[_i];
            }
            utils.each(rest, function (source) {
                for (var prop in source) {
                    if (source[prop] !== void 0) {
                        obj[prop] = source[prop];
                    }
                }
            });
            return obj;
        },
        // 剔除掉value为空的property
        stripEmptyProperties: function (obj) {
            var ret = {};
            utils.each(obj, function (v, k) {
                if (utils.isString(v) && v.length > 0) {
                    ret[k] = v;
                }
            });
            return ret;
        },
        keys: function (obj) {
            var results = [];
            if (obj == null) {
                return results;
            }
            utils.each(obj, function (value, key) {
                results[results.length] = key;
            });
            return results;
        },
        values: function (obj) {
            var results = [];
            if (obj == null) {
                return results;
            }
            utils.each(obj, function (value) {
                results[results.length] = value;
            });
            return results;
        },
        toArray: function (iterable) {
            if (!iterable) {
                return [];
            }
            if (iterable.toArray) {
                return iterable.toArray();
            }
            if (utils.isArray(iterable)) {
                return slice.call(iterable);
            }
            if (utils.isArguments(iterable)) {
                return slice.call(iterable);
            }
            return utils.values(iterable);
        },
        map: function (arr, callback, context) {
            if (nativeMap && arr.map === nativeMap) {
                return arr.map(callback, context);
            }
            else {
                var results_1 = [];
                utils.each(arr, function (item) {
                    results_1.push(callback.call(context, item));
                });
                return results_1;
            }
        },
        include: function (obj, target) {
            var found = false;
            if (obj == null) {
                return found;
            }
            if (nativeIndexOf && obj.indexOf === nativeIndexOf) {
                return obj.indexOf(target) !== -1;
            }
            utils.each(obj, function (value) {
                if (found || (found = (value === target))) {
                    return breaker;
                }
            });
            return found;
        },
        includes: function (str, needle) {
            return str.indexOf(needle) !== -1;
        },
        // TODO: inherit method
        now: function () {
            Date.now = Date.now || function () {
                return +new Date();
            };
            return Date.now();
        },
        safeWrap: function (f) {
            var func = f;
            return function () {
                try {
                    if (typeof f === 'undefined') { //ie8及以下
                        return func.apply(this, arguments);
                    }
                    else {
                        return f.apply(this, arguments);
                    }
                }
                catch (e) {
                    console$1.critical('Implementation error. Please turn on debug and contact support@Yata.com');
                    if (CONFIG.DEBUG) {
                        console$1.critical(e);
                    }
                }
            };
        },
        // TODO: safewrap_class
        // TODO: safewrap_instance_methods
        // TODO: strip_empty_properties
        extractDomain: function (hostname) {
            var domainRegex = DOMAIN_MATCH_REGEX;
            var parts = hostname.split('.');
            var tld = parts[parts.length - 1];
            if (tld.length > 4 || tld === 'com' || tld === 'org') {
                domainRegex = SIMPLE_DOMAIN_MATCH_REGEX;
            }
            var matches = hostname.match(domainRegex);
            return matches ? matches[0] : '';
        },
        truncate: function (target, length) {
            var ret = {};
            if (typeof target === 'string') {
                ret = target.slice(0, length);
            }
            else if (utils.isArray(target)) {
                ret = [];
                utils.each(target, function (val) {
                    ret.push(utils.truncate(val, length));
                });
            }
            else if (utils.isObject(target)) {
                ret = {};
                utils.each(target, function (val, key) {
                    ret[key] = utils.truncate(val, length);
                });
            }
            else {
                ret = target;
            }
            return ret;
        },
        encodeDates: function (obj) {
            utils.each(obj, function (v, k) {
                if (utils.isDate(v)) {
                    obj[k] = utils.formatDate(v);
                }
                else if (utils.isObject(v)) {
                    obj[k] = utils.encodeDates(v);
                }
            });
            return obj;
        },
        formatDate: function (date, fmt) {
            if (fmt === void 0) { fmt = 'YYYY-MM-DD HH:mm:ss'; }
            if (!date) {
                return '';
            }
            if (typeof date === 'string') {
                date = new Date(date.replace(/-/g, '/'));
            }
            if (typeof date === 'number') {
                date = new Date(date);
            }
            var o = {
                'M+': date.getMonth() + 1,
                'D+': date.getDate(),
                'h+': date.getHours() % 12 === 0 ? 12 : date.getHours() % 12,
                'H+': date.getHours(),
                'm+': date.getMinutes(),
                's+': date.getSeconds(),
                'q+': Math.floor((date.getMonth() + 3) / 3),
                S: date.getMilliseconds()
            };
            var week = {
                0: '\u65e5',
                1: '\u4e00',
                2: '\u4e8c',
                3: '\u4e09',
                4: '\u56db',
                5: '\u4e94',
                6: '\u516d'
            };
            if (/(Y+)/.test(fmt)) {
                fmt = fmt.replace(RegExp.$1, (date.getFullYear() + '').substr(4 - RegExp.$1.length));
            }
            if (/(E+)/.test(fmt)) {
                var str = '';
                if (RegExp.$1.length > 1) {
                    if (RegExp.$1.length > 2) {
                        str = '\u661f\u671f';
                    }
                    else {
                        str = '\u5468';
                    }
                }
                str = "" + str + week[date.getDay()];
                // fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? '\u661f\u671f' : '\u5468') : '') + week[date.getDay() + '']);
                fmt = fmt.replace(RegExp.$1, str);
            }
            for (var k in o) {
                if (new RegExp('(' + k + ')').test(fmt)) {
                    fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (('00' + o[k]).substr(('' + o[k]).length)));
                }
            }
            return fmt;
        }
    };
    var SIMPLE_DOMAIN_MATCH_REGEX = /[a-z0-9][a-z0-9-]*\.[a-z]+$/i;
    var DOMAIN_MATCH_REGEX = /[a-z0-9][a-z0-9-]+\.[a-z.]{2,6}$/i;
    var cheap_guid = function (maxLen) {
        var guid = Math.random().toString(36).substring(2, 10) + Math.random().toString(36).substring(2, 10);
        return maxLen ? guid.substring(0, maxLen) : guid;
    };
    var parseCookieString = function (text, shouldDecode) {
        var cookies = {};
        if (utils.isString(text) && text.length > 0) {
            var decodeValue = shouldDecode ? decodeURIComponent : function (s) { return s; };
            var cookieParts = text.split(/;\s/g);
            var cookieName = void 0;
            var cookieValue = void 0;
            var cookieNameValue = void 0;
            for (var i = 0, len = cookieParts.length; i < len; i++) {
                // Check for normally-formatted cookie (name-value)
                cookieNameValue = cookieParts[i].match(/([^=]+)=/i);
                if (cookieNameValue instanceof Array) {
                    try {
                        cookieName = decodeURIComponent(cookieNameValue[1]);
                        cookieValue = decodeValue(cookieParts[i].substring(cookieNameValue[1].length + 1));
                    }
                    catch (ex) {
                        // Intentionally ignore the cookie -
                        // the encoding is wrong
                    }
                }
                else {
                    // Means the cookie does not have an "=", so treat it as
                    // a boolean flag
                    cookieName = decodeURIComponent(cookieParts[i]);
                    cookieValue = '';
                }
                if (cookieName) {
                    cookies[cookieName] = cookieValue;
                }
            }
        }
        return cookies;
    };
    var validateCookieName = function (name) {
        if (utils.isString(name) && utils.trim(name) === '') {
            throw new TypeError('Cookie name must be a non-empty string');
        }
    };
    var Cookie = /** @class */ (function () {
        function Cookie() {
        }
        Cookie.prototype.get = function (name, options) {
            validateCookieName(name);
            if (typeof options === 'function') {
                options = {
                    converter: options
                };
            }
            else {
                options = options || {};
            }
            var cookies = parseCookieString(document.cookie, !options.raw);
            return (options.converter || (function (s) { return s; }))(cookies[name]);
        };
        Cookie.prototype.set = function (name, value, options) {
            validateCookieName(name);
            options = options || {};
            var expires = options.expires, domain = options.domain, path = options.path, raw = options.raw, secure = options.secure;
            if (!raw) {
                value = encodeURIComponent(String(value));
            }
            var text = name + '=' + value;
            // expires
            var date = expires;
            if (typeof date === 'number') {
                date = new Date();
                date.setDate(date.getDate() + expires);
            }
            if (date instanceof Date) {
                text += '; expires=' + date.toUTCString();
            }
            // domain
            if (utils.isString(domain) && utils.trim(domain) !== '') {
                text += '; domain=' + domain;
            }
            // path
            if (utils.isString(path) && utils.trim(path) !== '') {
                text += '; path=' + path;
            }
            // secure
            if (secure) {
                text += '; secure';
            }
            document.cookie = text;
            return text;
        };
        Cookie.prototype.remove = function (name, options) {
            options = options || {};
            options.expires = new Date(0);
            return this.set(name, '', options);
        };
        return Cookie;
    }());
    var _localStorageSupported = null;
    var localStorageSupported = function (storage, forceCheck) {
        if (_localStorageSupported != null && !forceCheck) {
            return _localStorageSupported;
        }
        var supported = true;
        try {
            storage = storage || window.localStorage;
            var key = '__jess_' + cheap_guid(8);
            var val = 'xyz';
            storage.setItem(key, val);
            if (storage.getItem(key) !== val) {
                supported = false;
            }
            storage.removeItem(key);
        }
        catch (e) {
            supported = false;
        }
        _localStorageSupported = supported;
        return supported;
    };
    // for 32 bit UUID method
    var UUID32 = (function (uuidRegEx, uuidReplacer) {
        return function () {
            return "xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx".replace(uuidRegEx, uuidReplacer).toUpperCase();
        };
    })(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0, v = c == "x" ? r : (r & 3 | 8);
        return v.toString(16);
    });
    var UUID = (function () {
        // Time/ticks information
        // 1*new Date() is a cross browser version of Date.now()
        var T = function () {
            var d = utils.now(), i = 0;
            // this while loop figures how many browser ticks go by
            // before 1*new Date() returns a new number, ie the amount
            // of ticks that go by per millisecond
            while (d == utils.now()) {
                i++;
            }
            return d.toString(16) + i.toString(16);
        };
        // Math.Random entropy
        var R = function () {
            return Math.random().toString(16).replace('.', '');
        };
        // User agent entropy
        // This function takes the user agent string, and then xors
        // together each sequence of 8 bytes.  This produces a final
        // sequence of 8 bytes which it returns as hex.
        var UA = function () {
            var ua = userAgent, i, ch, buffer = [], ret = 0;
            function xor(result, byte_array) {
                var j, tmp = 0;
                for (j = 0; j < byte_array.length; j++) {
                    tmp |= (buffer[j] << j * 8);
                }
                return result ^ tmp;
            }
            for (i = 0; i < ua.length; i++) {
                ch = ua.charCodeAt(i);
                buffer.unshift(ch & 0xFF);
                if (buffer.length >= 4) {
                    ret = xor(ret, buffer);
                    buffer = [];
                }
            }
            if (buffer.length > 0) {
                ret = xor(ret, buffer);
            }
            return ret.toString(16);
        };
        return function () {
            var se = (screen.height * screen.width).toString(16);
            return (T() + '-' + R() + '-' + UA() + '-' + se + '-' + T());
        };
    })();
    var JSONEncode = function (mixedVal) {
        var value = mixedVal;
        var quote = function (string) {
            var escapable = /[\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g; // eslint-disable-line no-control-regex
            var meta = {
                '\b': '\\b',
                '\t': '\\t',
                '\n': '\\n',
                '\f': '\\f',
                '\r': '\\r',
                '"': '\\"',
                '\\': '\\\\'
            };
            escapable.lastIndex = 0;
            if (escapable.test(string)) {
                string = string.replace(escapable, function (a) {
                    var c = meta[a];
                    return utils.isString(c) ? c : '\\u' + ('0000' + a.charCodeAt(0).toString(16).slice(-4));
                });
            }
            return "\"" + string + "\"";
        };
        var str = function (key, holder) {
            var gap = '';
            var indent = '  ';
            var i = 0;
            var k = '';
            var v = '';
            var length = 0;
            var mind = gap;
            var partial = [];
            var value = holder[key];
            if (value && typeof value === 'object' && typeof value.toJSON === 'function') {
                value = value.toJSON(key);
            }
            switch (typeof value) {
                case 'string':
                    return quote(value);
                case 'number':
                    return isFinite(value) ? String(value) : 'undefined';
                case 'boolean':
                case 'undefined':
                    return String(value);
                case 'object':
                    if (!value) {
                        return 'undefined';
                    }
                    gap += indent;
                    partial = [];
                    if (toStr.apply(value) === '[object Array]') {
                        length = value.length;
                        for (i = 0; i < length; i += 1) {
                            partial[i] = str(i, value) || 'undefined';
                        }
                        v = partial.length === 0 ?
                            '[]' :
                            gap ?
                                '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']' :
                                '[' + partial.join(',') + ']';
                        gap = mind;
                        return v;
                    }
                    for (k in value) {
                        if (hasOwnProperty.call(value, k)) {
                            v = str(k, value);
                            if (v) {
                                partial.push(quote(k) + (gap ? ': ' : ':') + v);
                            }
                        }
                    }
                    v = partial.length === 0 ?
                        '{}' :
                        gap ?
                            '{' + partial.join(',') + '' + mind + '}' :
                            '{' + partial.join(',') + '}';
                    gap = mind;
                    return v;
            }
        };
        return str('', {
            '': value
        });
    };
    // TODO: JSONDecode
    var JSONDecode = function () {
    };
    var Base64 = /** @class */ (function () {
        function Base64() {
        }
        // private method for UTF-8 encoding
        Base64._utf8_encode = function (string) {
            string = string.replace(/\r\n/g, '\n');
            var utftext = '';
            for (var n = 0; n < string.length; n++) {
                var c = string.charCodeAt(n);
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if (c > 127 && c < 2048) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
            }
            return utftext;
        };
        // private method for UTF-8 decoding
        Base64._utf8_decode = function (utftext) {
            var string = '';
            var i = 0;
            var c = 0, c2 = 0, c3 = 0;
            while (i < utftext.length) {
                c = utftext.charCodeAt(i);
                if (c < 128) {
                    string += String.fromCharCode(c);
                    i++;
                }
                else if (c > 191 && c < 224) {
                    c2 = utftext.charCodeAt(i + 1);
                    string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                }
                else {
                    c2 = utftext.charCodeAt(i + 1);
                    c3 = utftext.charCodeAt(i + 2);
                    string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                }
            }
            return string;
        };
        // public method for encoding
        Base64.encode = function (input) {
            var output = '';
            var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
            var i = 0;
            input = Base64._utf8_encode(input);
            while (i < input.length) {
                chr1 = input.charCodeAt(i++);
                chr2 = input.charCodeAt(i++);
                chr3 = input.charCodeAt(i++);
                enc1 = chr1 >> 2;
                enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                enc4 = chr3 & 63;
                if (isNaN(chr2)) {
                    enc3 = enc4 = 64;
                }
                else if (isNaN(chr3)) {
                    enc4 = 64;
                }
                output = output + this.keyStr.charAt(enc1) + this.keyStr.charAt(enc2) + this.keyStr.charAt(enc3) + this.keyStr.charAt(enc4);
            }
            return output;
        };
        // public method for decoding
        Base64.decode = function (input) {
            var output = '';
            var chr1, chr2, chr3;
            var enc1, enc2, enc3, enc4;
            var i = 0;
            input = input.replace(/[^A-Za-z0-9\+\/\=]/g, '');
            while (i < input.length) {
                enc1 = this.keyStr.indexOf(input.charAt(i++));
                enc2 = this.keyStr.indexOf(input.charAt(i++));
                enc3 = this.keyStr.indexOf(input.charAt(i++));
                enc4 = this.keyStr.indexOf(input.charAt(i++));
                chr1 = (enc1 << 2) | (enc2 >> 4);
                chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                chr3 = ((enc3 & 3) << 6) | enc4;
                output = output + String.fromCharCode(chr1);
                if (enc3 != 64) {
                    output = output + String.fromCharCode(chr2);
                }
                if (enc4 != 64) {
                    output = output + String.fromCharCode(chr3);
                }
            }
            output = Base64._utf8_decode(output);
            return output;
        };
        Base64.keyStr = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
        return Base64;
    }());
    var QueryStringify = function (obj, sep, eq, arrayKey) {
        if (sep === void 0) { sep = '&'; }
        if (eq === void 0) { eq = '='; }
        if (arrayKey === void 0) { arrayKey = false; }
        if (!utils.isPlainObject(obj))
            return '';
        sep = sep || '&';
        eq = eq || '=';
        arrayKey = arrayKey || false;
        var buf = [];
        var key, val;
        for (key in obj) {
            if (hasOwnProperty.call(obj, key)) {
                val = obj[key];
                key = encodeURIComponent(key);
                if (utils.isPrimitive(val)) {
                    buf.push(key, eq, encodeURIComponent("" + val), sep);
                }
                else if (utils.isArray(val) && val.length) {
                    for (var i = 0; i < val.length; i++) {
                        if (utils.isPrimitive(val[i])) {
                            buf.push(key, (arrayKey ? encodeURIComponent('[]') : '') + eq, encodeURIComponent("" + val[i]), sep);
                        }
                    }
                }
                else {
                    buf.push(key, eq, sep);
                }
            }
        }
        buf.pop();
        return buf.join('');
    };
    var JSONStringify = null;
    var JSONParse = null;
    if (typeof JSON !== 'undefined') {
        JSONStringify = JSON.stringify;
        JSONParse = JSON.parse;
    }
    JSONStringify = JSONStringify || JSONEncode;
    JSONParse = JSONParse || JSONDecode;
    var Info = /** @class */ (function () {
        function Info() {
        }
        // UTM(Urchin Tracking Module) 成为了网站跟踪参数的标准
        Info.campaignParams = function () {
            var campaignKeywords = 'utm_source utm_medium utm_campaign utm_content utm_term'.split(' '), params = {};
            var kw = '';
            utils.each(campaignKeywords, function (kwkey) {
                kw = utils.getQueryParam(doc.URL, kwkey);
                if (kw === null || kw === void 0 ? void 0 : kw.length) {
                    params[kwkey] = kw;
                }
            });
            return params;
        };
        Info.searchEngine = function (referrer) {
            if (referrer.search('https?://(.*)google.([^/?]*)') === 0) {
                return 'google';
            }
            else if (referrer.search('https?://(.*)bing.com') === 0) {
                return 'bing';
            }
            else if (referrer.search('https?://(.*)yahoo.com') === 0) {
                return 'yahoo';
            }
            else if (referrer.search('https?://(.*)duckduckgo.com') === 0) {
                return 'duckduckgo';
            }
            else {
                return null;
            }
        };
        Info.searchInfo = function (referrer) {
            var search = Info.searchEngine(referrer), ret = {};
            if (search != null) {
                ret['$search_engine'] = search;
            }
            return ret;
        };
        Info.referringDomain = function (referrer) {
            var split = referrer.split('/');
            if (split.length >= 3) {
                return split[2];
            }
            return '';
        };
        Info.browser = function (userAgent, vendor, opera) {
            if (userAgent === void 0) { userAgent = nav.userAgent; }
            vendor = vendor || nav.vendor || ''; // vendor is undefined for at least IE9
            if (opera || utils.includes(userAgent, ' OPR/')) {
                if (utils.includes(userAgent, 'Mini')) {
                    return 'Opera Mini';
                }
                return 'Opera';
            }
            else if (/(BlackBerry|PlayBook|BB10)/i.test(userAgent)) {
                return 'BlackBerry';
            }
            else if (utils.includes(userAgent, 'IEMobile') || utils.includes(userAgent, 'WPDesktop')) {
                return 'Internet Explorer Mobile';
            }
            else if (utils.includes(userAgent, 'SamsungBrowser/')) {
                // https://developer.samsung.com/internet/user-agent-string-format
                return 'Samsung Internet';
            }
            else if (utils.includes(userAgent, 'Edge') || utils.includes(userAgent, 'Edg/')) {
                return 'Microsoft Edge';
            }
            else if (utils.includes(userAgent, 'FBIOS')) {
                return 'Facebook Mobile';
            }
            else if (utils.includes(userAgent, 'Chrome')) {
                return 'Chrome';
            }
            else if (utils.includes(userAgent, 'CriOS')) {
                return 'Chrome iOS';
            }
            else if (utils.includes(userAgent, 'UCWEB') || utils.includes(userAgent, 'UCBrowser')) {
                return 'UC Browser';
            }
            else if (utils.includes(userAgent, 'FxiOS')) {
                return 'Firefox iOS';
            }
            else if (utils.includes(vendor, 'Apple')) {
                if (utils.includes(userAgent, 'Mobile')) {
                    return 'Mobile Safari';
                }
                return 'Safari';
            }
            else if (utils.includes(userAgent, 'Android')) {
                return 'Android Mobile';
            }
            else if (utils.includes(userAgent, 'Konqueror')) {
                return 'Konqueror';
            }
            else if (utils.includes(userAgent, 'Firefox')) {
                return 'Firefox';
            }
            else if (utils.includes(userAgent, 'MSIE') || utils.includes(userAgent, 'Trident/')) {
                return 'Internet Explorer';
            }
            else if (utils.includes(userAgent, 'Gecko')) {
                return 'Mozilla';
            }
            else {
                return '';
            }
        };
        Info.browserVersion = function (userAgent, vendor, opera) {
            if (userAgent === void 0) { userAgent = nav.userAgent; }
            var browser = Info.browser(userAgent, vendor, opera);
            var versionRegexp = {
                'Internet Explorer Mobile': /rv:(\d+(\.\d+)?)/,
                'Microsoft Edge': /Edge?\/(\d+(\.\d+)?)/,
                'Chrome': /Chrome\/(\d+(\.\d+)?)/,
                'Chrome iOS': /CriOS\/(\d+(\.\d+)?)/,
                'UC Browser': /(UCBrowser|UCWEB)\/(\d+(\.\d+)?)/,
                'Safari': /Version\/(\d+(\.\d+)?)/,
                'Mobile Safari': /Version\/(\d+(\.\d+)?)/,
                'Opera': /(Opera|OPR)\/(\d+(\.\d+)?)/,
                'Firefox': /Firefox\/(\d+(\.\d+)?)/,
                'Firefox iOS': /FxiOS\/(\d+(\.\d+)?)/,
                'Konqueror': /Konqueror:(\d+(\.\d+)?)/,
                'BlackBerry': /BlackBerry (\d+(\.\d+)?)/,
                'Android Mobile': /android\s(\d+(\.\d+)?)/,
                'Samsung Internet': /SamsungBrowser\/(\d+(\.\d+)?)/,
                'Internet Explorer': /(rv:|MSIE )(\d+(\.\d+)?)/,
                'Mozilla': /rv:(\d+(\.\d+)?)/
            };
            var regex = versionRegexp[browser];
            if (regex === undefined) {
                return '';
            }
            var matches = userAgent.match(regex);
            if (!matches) {
                return '';
            }
            return parseFloat(matches[matches.length - 2]);
        };
        Info.os = function () {
            var a = userAgent;
            if (/Windows/i.test(a)) {
                if (/Phone/.test(a) || /WPDesktop/.test(a)) {
                    return 'Windows Phone';
                }
                return 'Windows';
            }
            else if (/(iPhone|iPad|iPod)/.test(a)) {
                return 'iOS';
            }
            else if (/Android/.test(a)) {
                return 'Android';
            }
            else if (/(BlackBerry|PlayBook|BB10)/i.test(a)) {
                return 'BlackBerry';
            }
            else if (/Mac/i.test(a)) {
                return 'Mac OS X';
            }
            else if (/Linux/.test(a)) {
                return 'Linux';
            }
            else if (/CrOS/.test(a)) {
                return 'Chrome OS';
            }
            else {
                return '';
            }
        };
        Info.device = function (user_agent) {
            if (user_agent === void 0) { user_agent = nav.userAgent; }
            if (/Windows Phone/i.test(user_agent) || /WPDesktop/.test(user_agent)) {
                return 'Windows Phone';
            }
            else if (/iPad/.test(user_agent)) {
                return 'iPad';
            }
            else if (/iPod/.test(user_agent)) {
                return 'iPod Touch';
            }
            else if (/iPhone/.test(user_agent)) {
                return 'iPhone';
            }
            else if (/(BlackBerry|PlayBook|BB10)/i.test(user_agent)) {
                return 'BlackBerry';
            }
            else if (/Android/.test(user_agent)) {
                return 'Android';
            }
            else {
                return '';
            }
        };
        Info.getNetworkType = function (user_agent) {
            if (user_agent === void 0) { user_agent = nav.userAgent; }
            var networkStr = user_agent.match(/NetType\/\w+/) ? user_agent.match(/NetType\/\w+/)[0] : 'NetType/other';
            var networkType = networkStr.toLowerCase().replace('nettype/', '');
            if (networkType === 'wifi') {
                return 'wifi';
            }
            else if (networkType === '5g') {
                return '5G';
            }
            else if (networkType === '4g') {
                return '4G';
            }
            else if (networkType === '3g' || networkType === '3gnet') {
                return '3G';
            }
            else {
                if (nav.connection) {
                    return nav.connection.type;
                }
                return '';
            }
        };
        Info.profileProperties = function () {
            return utils.extend(utils.stripEmptyProperties({
                '$os': Info.os(),
                '$browser': Info.browser(userAgent, nav.vendor, win.opera)
            }), {
                '$browser_version': Info.browserVersion(userAgent, nav.vendor, win.opera)
            });
        };
        Info.properties = function () {
            return utils.extend(utils.stripEmptyProperties({}), {
                // appversion: '1.6.1',
                sdkversion: CONFIG.LIB_VERSION,
                system: Info.os(),
                vendor: Info.device(),
                // devicemodel: '',
                devicepixelratio: win.devicePixelRatio || '',
                // idfaorimei: '',
                // theme: '',
                platform: Info.browser(),
                platformversion: Info.browserVersion(),
                browser: Info.browser(),
                browserversion: Info.browserVersion(),
                screenwidth: screen.width,
                screenheight: screen.height,
                time: utils.now(),
                stampid: UUID32(),
                pageid: win.location.href,
                // sessionid: '',
                sendnetwork: Info.getNetworkType(),
                operator: '',
                // channel: '',
                referrer: doc.referrer
            });
        };
        Info.pageViewInfo = function () {
            return utils.stripEmptyProperties({});
        };
        return Info;
    }());
    // Performance utils
    var roundByFour = function (num) {
        return parseFloat(num.toFixed(4));
    };
    var convertToKB = function (bytes) {
        if (typeof bytes !== 'number') {
            return null;
        }
        return roundByFour(bytes / Math.pow(1024, 2));
    };
    /**
     * PushTask to requestIdleCallback
     */
    var pushTask = function (cb) {
        if ('requestIdleCallback' in win) {
            win.requestIdleCallback(cb, { timeout: 3000 });
        }
        else {
            setTimeout(function () {
                cb && cb();
            }, 100);
        }
    };

    var logger$1 = consoleWithPrefix('batch');
    // 进行 guid 筛选，未被标注为 true 的 id 字段进行归纳，返回数组列表
    var filterOutIDsAndInvalid = function (items, idSet) {
        var filteredItems = [];
        utils.each(items, function (item) {
            if (item.id && !idSet[item.id]) {
                filteredItems.push(item);
            }
        });
        return filteredItems;
    };
    // 更新 payload 内容，更新内容有重复的进行覆盖更新，不需要更新的直接复制，返回新数组对象
    var updatePayloads = function (existingItems, itemsToUpdate) {
        var newItems = [];
        utils.each(existingItems, function (item) {
            var id = item['id'];
            if (id in itemsToUpdate) {
                var newPayload = itemsToUpdate[id];
                if (newPayload != null) {
                    item['payload'] = newPayload;
                    newItems.push(item);
                }
            }
            else {
                newItems.push(item);
            }
        });
        return newItems;
    };
    // 请求队列处理类，包括入列，去重，更行等操作
    var RequestQueue = /** @class */ (function () {
        function RequestQueue(storageKey, options) {
            options = options || {};
            this.storageKey = storageKey;
            this.storage = options.storage || win.localStorage;
            this.pid = options.pid || undefined;
            this.memQueue = [];
        }
        // 入列操作，初始化常用入列内容并入本地数组列中，更新到本地存储同时同步到 memQueue 对象缓存，通过回调返回存储状态
        RequestQueue.prototype.enqueue = function (item, flushInterval, cb) {
            var queueEntry = {
                id: cheap_guid(),
                flushAfter: utils.now() + flushInterval * 2,
                payload: item
            };
            var succeed;
            try {
                var storageQueue = this.readFromStorage();
                storageQueue.push(queueEntry);
                succeed = this.saveToStorage(storageQueue);
                if (succeed) {
                    this.memQueue.push(queueEntry);
                }
            }
            catch (e) {
                logger$1.error('Error enqueueing item', item);
                succeed = false;
            }
            if (cb) {
                cb(succeed);
            }
        };
        // 从提供的 key 来获取本地存储内容并解析成 JSON 对象，存储内容应为数组类型；访问不到返回空数组
        RequestQueue.prototype.readFromStorage = function () {
            var storageEntry;
            try {
                storageEntry = this.storage.getItem(this.storageKey);
                if (storageEntry) {
                    storageEntry = JSONParse(storageEntry);
                    if (!utils.isArray(storageEntry)) {
                        logger$1.error('Invalid storage entry:', storageEntry);
                        storageEntry = null;
                    }
                }
            }
            catch (e) {
                logger$1.error('Error retrieving queue:', e);
                storageEntry = null;
            }
            return storageEntry || [];
        };
        // 根据提供的 key 进行本地存储，返回 true/false
        RequestQueue.prototype.saveToStorage = function (queue) {
            try {
                this.storage.setItem(this.storageKey, JSONStringify(queue));
                return true;
            }
            catch (e) {
                logger$1.error('Error saving queue', e);
                return false;
            }
        };
        // 排除指定的 ids 对象，同时从 memQueue 缓存中剔除并更新本地队列
        RequestQueue.prototype.removeItemsByID = function (ids, cb) {
            var idSet = {};
            utils.each(ids, function (id) {
                idSet[id] = true;
            });
            this.memQueue = filterOutIDsAndInvalid(this.memQueue, idSet);
            var succeeded;
            try {
                var storedQueue = this.readFromStorage();
                storedQueue = filterOutIDsAndInvalid(storedQueue, idSet);
                succeeded = this.saveToStorage(storedQueue);
            }
            catch (e) {
                logger$1.error('Error removing items', ids);
                succeeded = false;
            }
            if (cb) {
                cb(succeeded);
            }
        };
        // 补充批量数据，当缓存数据不够指定数量时，从本地缓存中预查是否有满足条件的
        // 进行补充；（本地存储中那些缓存中不存在且超出 flush 时长的符合递补条件，即为遗留的数据）
        RequestQueue.prototype.fillBatch = function (batchSize) {
            var batch = this.memQueue.slice(0, batchSize);
            if (batch.length < batchSize) {
                var storedQueue = this.readFromStorage();
                if (storedQueue.length) {
                    // 数据ID已经在memQueue中，不要重复添加
                    var idsInBatch_1 = {};
                    utils.each(batch, function (item) {
                        idsInBatch_1[item.id] = true;
                    });
                    for (var i = 0; i < storedQueue.length; i++) {
                        var item = storedQueue[i];
                        // 现在的时间大于每条数据的 flushAfter 时间，并且该条数据不在memQueue中
                        if (utils.now() > item.flushAfter && !idsInBatch_1[item.id]) {
                            item.orphaned = true; //可丢弃的？
                            batch.push(item);
                            if (batch.length >= batchSize) {
                                break;
                            }
                        }
                    }
                }
            }
            return batch;
        };
        // 函数重载，同名函数，对外暴露使用且返回更新状态给外部可知
        RequestQueue.prototype.updatePayloads = function (itemsToUpdate, cb) {
            this.memQueue = updatePayloads(this.memQueue, itemsToUpdate);
            var succeeded;
            try {
                var storedQueue = this.readFromStorage();
                storedQueue = updatePayloads(storedQueue, itemsToUpdate);
                succeeded = this.saveToStorage(storedQueue);
            }
            catch (e) {
                logger$1.error('Error updating items', itemsToUpdate);
                succeeded = false;
            }
            if (cb) {
                cb(succeeded);
            }
        };
        return RequestQueue;
    }());

    var MAX_RETRY_INTERVAL_MS = 10 * 60 * 1000; // 10 minutes
    var logger = consoleWithPrefix('batch');
    var RequestBatcher = /** @class */ (function () {
        function RequestBatcher(storageKey, options) {
            // 初始化请求队列
            this.queue = new RequestQueue(storageKey, {
                storage: options.storage
            });
            this.libConfig = options.libConfig;
            this.sendRequest = options.sendRequestFunc;
            this.beforeSendHook = options.beforeSendHook;
            this.batchSize = this.libConfig.batch_size;
            this.flushInterval = this.libConfig.batch_flush_interval_ms;
            this.stopped = !this.libConfig.batch_auto_start;
        }
        // 入列保存在本地及 memQueue 缓存中
        RequestBatcher.prototype.enqueue = function (item, cb) {
            this.queue.enqueue(item, this.flushInterval, cb);
        };
        // 开始发起批量上报
        RequestBatcher.prototype.start = function () {
            this.stopped = false;
            this.flush();
        };
        // ☆☆实际核心上报函数☆☆
        RequestBatcher.prototype.flush = function (options) {
            var _this = this;
            try {
                if (this.requestInProgress) {
                    logger.log('Flush: Request already in progress');
                    return;
                }
                options = options || {};
                var timeoutMS_1 = this.libConfig.batch_request_timeout_ms;
                var startTime_1 = utils.now();
                var currentBatchSize_1 = this.batchSize;
                var batch_1 = this.queue.fillBatch(currentBatchSize_1); // 真实可批量上报的数据
                var dataForRequest_1 = []; // 请求具体数据
                var transformedItems_1 = {};
                utils.each(batch_1, function (item) {
                    var payload = item.payload;
                    if (_this.beforeSendHook && !item.orphaned) {
                        payload = _this.beforeSendHook(payload);
                    }
                    if (payload) {
                        dataForRequest_1.push(payload);
                    }
                    transformedItems_1[item.id] = payload;
                });
                // 默认启动定时器
                if (dataForRequest_1.length < 1) {
                    this.resetFlush();
                    return;
                }
                this.requestInProgress = true;
                var batchSendCallback = function (res) {
                    _this.requestInProgress = false;
                    try {
                        var removeItemsFromQueue = false;
                        if (options === null || options === void 0 ? void 0 : options.unloading) {
                            _this.queue.updatePayloads(transformedItems_1, function () {
                            });
                        }
                        else if (utils.isObject(res) && res.error === 'timeout' && utils.now() - startTime_1 >= timeoutMS_1) {
                            logger.error('Network timeout; retrying');
                            _this.flush();
                        }
                        else if (utils.isObject(res) && res.xhr_req && (res.xhr_req.status >= 500 || res.xhr_req.status <= 0)) {
                            var retryMS = _this.flushInterval * 2;
                            var headers = res.xhr_req.responseHeaders;
                            if (headers) {
                                var retryAfter = headers['Retry-After'];
                                if (retryAfter) {
                                    retryMS = (parseInt(retryAfter, 10) * 1000) || retryMS;
                                }
                            }
                            retryMS = Math.min(MAX_RETRY_INTERVAL_MS, retryMS);
                            logger.error('Error; retry in ' + retryMS + ' ms');
                            _this.scheduleFlush(retryMS);
                        }
                        else if (utils.isObject(res) && res.data && res.data.allowCollection === 'N') { // 针对特定 Code 停发
                            _this.stopped = true;
                        }
                        else if (utils.isObject(res) && res.xhr_req && res.xhr_req.status === 413) {
                            if (batch_1.length > 1) {
                                var halvedBatchSize = Math.max(1, Math.floor(currentBatchSize_1 / 2));
                                _this.batchSize = Math.min(_this.batchSize, halvedBatchSize, batch_1.length - 1);
                                logger.error('413 response; reducing batch size to ' + _this.batchSize);
                                _this.resetFlush();
                            }
                            else {
                                logger.error('Single-event request too large; dropping', batch_1);
                                _this.resetBatchSize();
                                removeItemsFromQueue = true;
                            }
                        }
                        else {
                            removeItemsFromQueue = true;
                        }
                        if (removeItemsFromQueue) {
                            _this.queue.removeItemsByID(utils.map(batch_1, function (item) { return item.id; }), utils.bind(_this.flush, _this));
                        }
                    }
                    catch (e) {
                        logger.error('Error handling API response', e);
                        _this.resetFlush();
                    }
                };
                var requestOptions = {
                    method: 'POST',
                    verbose: true,
                    ignore_json_errors: true,
                    timeout_ms: timeoutMS_1
                };
                if (options.unloading) {
                    requestOptions.transport = 'SEND_BEACON';
                }
                logger.log('YATA REQUEST:', dataForRequest_1);
                this.sendRequest(dataForRequest_1, requestOptions, batchSendCallback);
            }
            catch (e) {
                logger.error('Error flushing request queue', e);
                this.resetFlush();
            }
        };
        RequestBatcher.prototype.scheduleFlush = function (flushMS) {
            var _this = this;
            this.flushInterval = flushMS;
            if (!this.stopped) {
                if (this.timeoutID) {
                    clearTimeout(this.timeoutID);
                    this.timeoutID = null;
                }
                this.timeoutID = setTimeout(function () { return _this.flush(); }, this.flushInterval);
            }
        };
        RequestBatcher.prototype.resetFlush = function () {
            this.scheduleFlush(this.libConfig.batch_flush_interval_ms);
        };
        RequestBatcher.prototype.resetBatchSize = function () {
            this.batchSize = this.libConfig.batch_size;
        };
        return RequestBatcher;
    }());

    var ACTIONS;
    (function (ACTIONS) {
        ACTIONS["SET_ACTION"] = "$set";
        ACTIONS["SET_ONCE_ACTION"] = "$set_once";
        ACTIONS["UNSET_ACTION"] = "$unset";
        ACTIONS["ADD_ACTION"] = "$add";
        ACTIONS["APPEND_ACTION"] = "$append";
        ACTIONS["UNION_ACTION"] = "$union";
        ACTIONS["REMOVE_ACTION"] = "$remove";
        ACTIONS["DELETE_ACTION"] = "$delete";
    })(ACTIONS || (ACTIONS = {}));
    var ApiActions = /** @class */ (function () {
        function ApiActions() {
        }
        ApiActions.prototype.isReservedProperty = function (key) {
            return false;
        };
        ApiActions.prototype.setAction = function (prop, to) {
            var _this = this;
            var data = {};
            var $set = {};
            if (utils.isObject(prop)) {
                utils.each(prop, function (v, k) {
                    if (!_this.isReservedProperty(k)) {
                        $set[k] = v;
                    }
                });
            }
            else {
                $set[prop] = to;
            }
            data[ACTIONS.SET_ACTION] = $set;
            return data;
        };
        ApiActions.prototype.setOnceAction = function (prop, to) {
            var _this = this;
            var data = {};
            var $setOnce = {};
            if (utils.isObject(prop)) {
                utils.each(prop, function (v, k) {
                    if (!_this.isReservedProperty(k)) {
                        $setOnce[k] = v;
                    }
                });
            }
            else {
                $setOnce[prop] = to;
            }
            data[ACTIONS.SET_ONCE_ACTION] = $setOnce;
            return data;
        };
        ApiActions.prototype.unsetAction = function (prop) {
            var _this = this;
            var data = {};
            var $unset = [];
            if (!utils.isArray(prop)) {
                prop = [prop];
            }
            utils.each(prop, function (item) {
                if (!_this.isReservedProperty(item)) {
                    $unset.push(item);
                }
            });
            data[ACTIONS.UNSET_ACTION] = $unset;
            return data;
        };
        ApiActions.prototype.unionAction = function (listName, values) {
            var _this = this;
            var data = {};
            var $union = {};
            if (utils.isObject(listName)) {
                utils.each(listName, function (v, k) {
                    if (!_this.isReservedProperty(k)) {
                        $union[k] = utils.isArray(v) ? v : [v];
                    }
                });
            }
            else {
                $union[listName] = utils.isArray(values) ? values : [values];
            }
            data[ACTIONS.UNION_ACTION] = $union;
            return data;
        };
        ApiActions.prototype.appendAction = function (listName, value) {
            var _this = this;
            var data = {};
            var $append = {};
            if (utils.isObject(listName)) {
                utils.each(listName, function (v, k) {
                    if (!_this.isReservedProperty(k)) {
                        $append[k] = v;
                    }
                });
            }
            else {
                $append[listName] = value;
            }
            data[ACTIONS.APPEND_ACTION] = $append;
            return data;
        };
        ApiActions.prototype.removeAction = function (listName, value) {
            var _this = this;
            var data = {};
            var $remove = {};
            if (utils.isObject(listName)) {
                utils.each(listName, function (v, k) {
                    if (!_this.isReservedProperty(k)) {
                        $remove[k] = v;
                    }
                });
            }
            else {
                $remove[listName] = value;
            }
            data[ACTIONS.REMOVE_ACTION] = $remove;
            return data;
        };
        ApiActions.prototype.deleteAction = function () {
            var data = {};
            data[ACTIONS.DELETE_ACTION] = '';
            return data;
        };
        return ApiActions;
    }());

    var RESERVED_PROPERTIES;
    (function (RESERVED_PROPERTIES) {
        RESERVED_PROPERTIES["SET_QUEUE_KEY"] = "__jes";
        RESERVED_PROPERTIES["SET_ONCE_QUEUE_KEY"] = "__jeso";
        RESERVED_PROPERTIES["UNSET_QUEUE_KEY"] = "__jeus";
        RESERVED_PROPERTIES["ADD_QUEUE_KEY"] = "__jea";
        RESERVED_PROPERTIES["APPEND_QUEUE_KEY"] = "__jeap";
        RESERVED_PROPERTIES["REMOVE_QUEUE_KEY"] = "__jer";
        RESERVED_PROPERTIES["UNION_QUEUE_KEY"] = "__jeu";
        RESERVED_PROPERTIES["PEOPLE_DISTINCT_ID_KEY"] = "$people_distinct_id";
        RESERVED_PROPERTIES["ALIAS_ID_KEY"] = "__alias";
        RESERVED_PROPERTIES["CAMPAIGN_IDS_KEY"] = "__cmpns";
        RESERVED_PROPERTIES["EVENT_TIMERS_KEY"] = "__timers";
    })(RESERVED_PROPERTIES || (RESERVED_PROPERTIES = {}));
    var Persistence = /** @class */ (function () {
        function Persistence(config) {
            var _this = this;
            // 已过期的监测id从对象中移除
            this.expireNotificationCampaigns = utils.safeWrap(function () {
                var campaignsShown = _this.props[RESERVED_PROPERTIES.CAMPAIGN_IDS_KEY];
                var EXPIRY_TIME = CONFIG.DEBUG ? 60 * 1000 : 60 * 60 * 1000; // 1 minute (config.debug)
                if (!campaignsShown)
                    return;
                for (var campaignId in campaignsShown) {
                    if (campaignsShown.hasOwnProperty(campaignId) && utils.now() - campaignsShown[campaignId] > EXPIRY_TIME) {
                        delete campaignsShown[campaignId];
                    }
                }
                // 为空对象时删除 __cmpns 属性
                if (utils.isEmptyObject(campaignsShown)) {
                    delete _this.props[RESERVED_PROPERTIES.CAMPAIGN_IDS_KEY];
                }
            });
            this.props = {};
            this.campaign_params_saved = false;
            // 若设置持久化命名，则定义为 je_xxxx，否则默认为 je_appId_yata
            if (config.persistence_name) {
                this.name = 'je_' + config.persistence_name;
            }
            else {
                this.name = 'je_' + config.app_id + '_yata';
            }
            var storageType = config.persistence;
            if (storageType !== 'cookie' && storageType !== 'localStorage') {
                console$1.critical('Unknown persistence type ' + storageType + '; falling back to cookie');
                storageType = config.persistence = 'cookie'; // 类型不匹配时默认为 cookie
            }
            if (storageType === 'localStorage' && localStorageSupported()) {
                this.storage = win.localStorage;
            }
            else {
                this.storage = new Cookie();
            }
            this.load();
            this.updateConfig(config);
            this.upgrade(config);
            this.save();
        }
        // 获取除保留字属性之外的对象
        Persistence.prototype.properties = function () {
            var p = {};
            utils.each(this.props, function (v, k) {
                if (!utils.include(RESERVED_PROPERTIES, k)) {
                    p[k] = v;
                }
            });
            return p;
        };
        // 初始加载本地存储，根据 name 获取数据并赋值为 props
        Persistence.prototype.load = function () {
            if (this.disabled)
                return;
            var entry = this.storage.get(this.name);
            if (entry) {
                this.props = utils.extend({}, JSONParse(entry));
            }
        };
        Persistence.prototype.updateConfig = function (config) {
            this.default_expiry = this.expire_days = config.cookie_expiration; //获取配置项中过期时间
            this.setDisabled(config.disable_persistence); // 是否关闭本地持久化保存?
            this.setCookieDomain(config.cookie_domain);
            this.setCrossSite(config.cross_site_cookie);
            this.setCrossSubDomain(config.cross_sub_domain_cookie);
            this.setSecure(config.secure_cookie);
        };
        Persistence.prototype.upgrade = function (config) {
            /*let upgradeFromOldLib: boolean | string = config.upgrade,
              oldCookieName: string,
              oldCookie: string;
            if (upgradeFromOldLib) {
              oldCookieName = 'je_super_properties';
            }*/
        };
        // 未关闭持久化时，则重新设置 storage 对象
        Persistence.prototype.save = function () {
            if (this.disabled)
                return;
            this.expireNotificationCampaigns();
            this.storage.set(this.name, JSONStringify(this.props), {
                expires: this.expire_days,
                domain: utils.extractDomain(win.location.hostname),
                secure: this.secure
            });
        };
        Persistence.prototype.remove = function () {
            this.storage.remove(this.name);
        };
        // 从属性对象中获取 key
        Persistence.prototype.getQueue = function (queue) {
            return this.props[this.getQueueKey(queue)];
        };
        Persistence.prototype.getQueueKey = function (queue) {
            if (queue === ACTIONS.SET_ACTION) {
                return RESERVED_PROPERTIES.SET_QUEUE_KEY;
            }
            else if (queue === ACTIONS.SET_ONCE_ACTION) {
                return RESERVED_PROPERTIES.SET_ONCE_QUEUE_KEY;
            }
            else if (queue === ACTIONS.UNSET_ACTION) {
                return RESERVED_PROPERTIES.UNSET_QUEUE_KEY;
            }
            else if (queue === ACTIONS.ADD_ACTION) {
                return RESERVED_PROPERTIES.ADD_QUEUE_KEY;
            }
            else if (queue === ACTIONS.APPEND_ACTION) {
                return RESERVED_PROPERTIES.APPEND_QUEUE_KEY;
            }
            else if (queue === ACTIONS.REMOVE_ACTION) {
                return RESERVED_PROPERTIES.REMOVE_QUEUE_KEY;
            }
            else if (queue === ACTIONS.UNION_ACTION) {
                return RESERVED_PROPERTIES.UNION_QUEUE_KEY;
            }
            else {
                console$1.error('Invalid queue:', queue);
                return '';
            }
        };
        // 获取并创建对应 key 属性的对象
        Persistence.prototype.getOrCreateQueue = function (queue, defaultValue) {
            var key = this.getQueueKey(queue);
            defaultValue = utils.isUndefined(defaultValue) ? {} : defaultValue; // 未提供默认值时为 {}
            if (!this.props[key]) {
                this.props[key] = defaultValue;
            }
            return this.props[key];
        };
        Persistence.prototype.popFromPeopleQueue = function (queue, data) {
            this.getQueue(queue);
        };
        Persistence.prototype.addToPeopleQueue = function (queue, data) {
            var qKey = this.getQueueKey(queue), qData = data[queue], setQ = this.getOrCreateQueue(ACTIONS.SET_ACTION), setOnceQ = this.getOrCreateQueue(ACTIONS.SET_ONCE_ACTION), unsetQ = this.getOrCreateQueue(ACTIONS.UNSET_ACTION), addQ = this.getOrCreateQueue(ACTIONS.ADD_ACTION), unionQ = this.getOrCreateQueue(ACTIONS.UNION_ACTION), removeQ = this.getOrCreateQueue(ACTIONS.REMOVE_ACTION, []), appendQ = this.getOrCreateQueue(ACTIONS.APPEND_ACTION, []);
            if (qKey === RESERVED_PROPERTIES.SET_QUEUE_KEY) {
                utils.extend(setQ, qData);
                this.popFromPeopleQueue(ACTIONS.ADD_ACTION, qData);
                this.popFromPeopleQueue(ACTIONS.UNION_ACTION, qData);
                this.popFromPeopleQueue(ACTIONS.UNSET_ACTION, qData);
            }
            else if (qKey === RESERVED_PROPERTIES.SET_ONCE_QUEUE_KEY) {
                utils.each(qData, function (v, k) {
                    if (!(k in setOnceQ)) {
                        setOnceQ[k] = v;
                    }
                });
                this.popFromPeopleQueue(ACTIONS.UNSET_ACTION, qData);
            }
            else if (qKey === RESERVED_PROPERTIES.UNSET_QUEUE_KEY) {
                utils.each(qData, function (prop) {
                    utils.each([setQ, setOnceQ, addQ, unionQ], function (enqueuedObj) {
                        if (prop in enqueuedObj) {
                            delete enqueuedObj[prop];
                        }
                    });
                    utils.each(appendQ, function (appendObj) {
                        if (prop in appendObj) {
                            delete appendObj[prop];
                        }
                    });
                    unsetQ[prop] = true;
                });
            }
            else if (qKey === RESERVED_PROPERTIES.ADD_QUEUE_KEY) {
                utils.each(qData, function (v, k) {
                    if (k in setQ) {
                        setQ[k] += v;
                    }
                    else {
                        if (!(k in addQ)) {
                            addQ[k] = 0;
                        }
                        addQ[k] += v;
                    }
                });
                this.popFromPeopleQueue(ACTIONS.UNSET_ACTION, qData);
            }
            else if (qKey === RESERVED_PROPERTIES.UNION_QUEUE_KEY) {
                utils.each(qData, function (v, k) {
                    if (utils.isArray(v)) {
                        if (!(k in unionQ)) {
                            unionQ[k] = [];
                        }
                        // We may send duplicates, the server will dedup them.
                        unionQ[k] = unionQ[k].concat(v);
                    }
                });
                this.popFromPeopleQueue(ACTIONS.UNSET_ACTION, qData);
            }
            else if (qKey === RESERVED_PROPERTIES.REMOVE_QUEUE_KEY) {
                removeQ.push(qData);
                this.popFromPeopleQueue(ACTIONS.APPEND_ACTION, qData);
            }
            else if (qKey === RESERVED_PROPERTIES.APPEND_QUEUE_KEY) {
                appendQ.push(qData);
                this.popFromPeopleQueue(ACTIONS.UNSET_ACTION, qData);
            }
            console$1.log('YATA PEOPLE REQUEST (QUEUED, PENDING IDENTIFY)');
            console$1.log(data);
            this.save();
        };
        // 不重复注册到 this.props 对象中以及重置 expire_days 过期时间
        Persistence.prototype.registerOnce = function (props, defaultValue, days) {
            var _this = this;
            if (defaultValue === void 0) { defaultValue = 'None'; }
            if (utils.isObject(props)) {
                this.expire_days = typeof days === 'undefined' ? this.default_expiry : days;
                utils.each(props, function (val, prop) {
                    if (!_this.props.hasOwnProperty(prop) || _this.props[prop] === defaultValue) {
                        _this.props[prop] = val;
                    }
                });
                this.save();
                return true;
            }
            return false;
        };
        Persistence.prototype.setDisabled = function (disabled) {
            if (disabled !== this.disabled) {
                this.disabled = disabled;
                if (this.disabled) {
                    this.remove();
                }
                else {
                    this.save();
                }
            }
        };
        Persistence.prototype.setSecure = function (secure) {
            if (secure !== this.secure) {
                this.secure = secure;
                this.remove();
                this.save();
            }
        };
        // 若 cookieDomain 不同则重置
        Persistence.prototype.setCookieDomain = function (cookieDomain) {
            if (cookieDomain !== this.cookieDomain) {
                this.remove();
                this.cookieDomain = cookieDomain;
                this.save();
            }
        };
        Persistence.prototype.setCrossSite = function (crossSite) {
            if (crossSite !== this.crossSite) {
                this.crossSite = crossSite;
                this.remove();
                this.save();
            }
        };
        // 设置子域
        Persistence.prototype.setCrossSubDomain = function (crossSubDomain) {
            if (crossSubDomain !== this.crossSubDomain) {
                this.crossSubDomain = crossSubDomain;
                this.remove();
                this.save();
            }
        };
        // 设置事件定时器对象
        Persistence.prototype.setEventTimer = function (eventName, timestamp) {
            var timer = this.props[RESERVED_PROPERTIES.EVENT_TIMERS_KEY] || {};
            timer[eventName] = timestamp;
            this.props[RESERVED_PROPERTIES.EVENT_TIMERS_KEY] = timer;
            this.save();
        };
        // 与上个方法反之操作，删除
        Persistence.prototype.removeEventTimer = function (eventName) {
            var timer = this.props[RESERVED_PROPERTIES.EVENT_TIMERS_KEY] || {};
            var timestamp = timer[eventName];
            if (!utils.isUndefined(timestamp)) {
                delete this.props[RESERVED_PROPERTIES.EVENT_TIMERS_KEY][eventName];
            }
            return timestamp;
        };
        // 覆盖扩展属性到 props 对象中及设置过期日期
        Persistence.prototype.register = function (props, days) {
            if (utils.isObject(props)) {
                this.expire_days = typeof days === 'undefined' ? this.default_expiry : days;
                utils.extend(this.props, props);
                this.save();
                return true;
            }
            return false;
        };
        Persistence.prototype.unregister = function (prop) {
            if (prop in this.props) {
                delete this.props[prop];
                this.save();
            }
        };
        // 更新 utm 流量参数
        Persistence.prototype.updateCampaignParams = function () {
            if (!this.campaign_params_saved) {
                this.registerOnce(Info.campaignParams());
                this.campaign_params_saved = true;
            }
        };
        // 扩展 '$search_engine' = 'yahoo'...
        Persistence.prototype.updateSearchKeyword = function (referrer) {
            this.register(Info.searchInfo(referrer));
        };
        Persistence.prototype.updateReferrerInfo = function (referrer) {
            this.registerOnce({
                '$initial_referrer': referrer || '$direct',
                '$initial_referring_domain': Info.referringDomain(referrer) || '$direct'
            }, '');
        };
        Persistence.prototype.getReferrerInfo = function () {
            return utils.stripEmptyProperties({
                '$initial_referrer': this.props['$initial_referrer'],
                '$initial_referring_domain': this.props['$initial_referring_domain']
            });
        };
        return Persistence;
    }());

    var DEFAULT_CONFIG = {
        api_host: 'https://api.yata.com',
        api_method: 'POST',
        api_transport: 'XHR',
        app_host: 'https://yata.com',
        cdn: 'https://cdn.yata.com',
        cross_site_cookie: false,
        cross_sub_domain_cookie: false,
        persistence: 'cookie',
        persistence_name: '',
        cookie_domain: '',
        cookie_name: '',
        loaded: function () {
        },
        store_google: true,
        save_referrer: true,
        test: false,
        verbose: false,
        img: false,
        debug: false,
        track_links_timeout: 300,
        cookie_expiration: 365,
        upgrade: false,
        disable_persistence: false,
        disable_cookie: false,
        secure_cookie: false,
        ip: false,
        report_errors: true,
        use_perf: false,
        resourceTiming: false,
        resource_request_size: 10,
        property_block_list: [],
        xhr_headers: {},
        auth_params: {},
        ignore_dnt: false,
        batch_requests: false,
        batch_size: 10,
        batch_flush_interval_ms: 5000,
        batch_request_timeout_ms: 90000,
        batch_auto_start: true,
        hooks: {}
    };

    var Profile = /** @class */ (function (_super) {
        __extends(Profile, _super);
        function Profile(yata) {
            var _this = _super.call(this) || this;
            _this.yata = yata;
            return _this;
        }
        Profile.prototype.isReservedProperty = function (prop) {
            return ['$distinct_id', '$device_id', '$user_id', '$had_persisted_distinct_id'].indexOf(prop) > -1;
        };
        Profile.prototype.set = function (prop, to, callback) {
            var _a, _b;
            var data = this.setAction(prop, to);
            // 若首位参数为对象类型，则赋值 callback 为 to 参数
            if (utils.isObject(prop)) {
                callback = to;
            }
            // 获取是否保存页面来源 referrer 
            if (this.getConfig('save_referrer')) {
                (_a = this.yata.persistence) === null || _a === void 0 ? void 0 : _a.updateReferrerInfo(doc.referrer);
            }
            data[ACTIONS.SET_ACTION] = utils.extend({}, Info.profileProperties(), (_b = this.yata.persistence) === null || _b === void 0 ? void 0 : _b.getReferrerInfo(), data[ACTIONS.SET_ACTION]);
            return this.sendRequest(data, callback);
        };
        Profile.prototype.sendRequest = function (data, callback) {
            var _a;
            // data.$token = this.getConfig('token');
            data.$distinct_id = this.yata.getDistinctID();
            var deviceId = this.yata.getProperty('$device_id');
            var userId = this.yata.getProperty('$user_id');
            var hadPersistedDistinctId = this.yata.getProperty('$had_persisted_distinct_id');
            if (deviceId) {
                data.$device_id = deviceId;
            }
            if (userId) {
                data.$user_id = userId;
            }
            if (hadPersistedDistinctId) {
                data.$had_persisted_distinct_id = hadPersistedDistinctId;
            }
            var dateEncodedData = utils.encodeDates(data);
            if (!this.identifyCalled()) {
                this.enqueue(data);
                if (!utils.isUndefined(callback)) {
                    if (this.getConfig('verbose')) {
                        callback({ status: -1, error: null });
                    }
                    else {
                        callback(-1);
                    }
                }
                return utils.truncate(dateEncodedData, 255);
            }
            return this.yata.trackOrBatch({
                type: 'people',
                data: dateEncodedData,
                endpoint: this.getConfig('api_host') + '/engage',
                batcher: (_a = this.yata.request_batchers) === null || _a === void 0 ? void 0 : _a.people
            }, callback);
        };
        Profile.prototype.getConfig = function (prop) {
            return this.yata.getConfig(prop);
        };
        Profile.prototype.identifyCalled = function () {
            var _a;
            return ((_a = this.yata.flag) === null || _a === void 0 ? void 0 : _a.identify_called) === true;
        };
        Profile.prototype.enqueue = function (data) {
            var _a, _b, _c, _d, _e, _f, _g;
            if (ACTIONS.SET_ACTION in data) {
                (_a = this.yata.persistence) === null || _a === void 0 ? void 0 : _a.addToPeopleQueue(ACTIONS.SET_ACTION, data);
            }
            else if (ACTIONS.SET_ONCE_ACTION in data) {
                (_b = this.yata.persistence) === null || _b === void 0 ? void 0 : _b.addToPeopleQueue(ACTIONS.SET_ONCE_ACTION, data);
            }
            else if (ACTIONS.UNSET_ACTION in data) {
                (_c = this.yata.persistence) === null || _c === void 0 ? void 0 : _c.addToPeopleQueue(ACTIONS.UNSET_ACTION, data);
            }
            else if (ACTIONS.ADD_ACTION in data) {
                (_d = this.yata.persistence) === null || _d === void 0 ? void 0 : _d.addToPeopleQueue(ACTIONS.ADD_ACTION, data);
            }
            else if (ACTIONS.APPEND_ACTION in data) {
                (_e = this.yata.persistence) === null || _e === void 0 ? void 0 : _e.addToPeopleQueue(ACTIONS.APPEND_ACTION, data);
            }
            else if (ACTIONS.REMOVE_ACTION in data) {
                (_f = this.yata.persistence) === null || _f === void 0 ? void 0 : _f.addToPeopleQueue(ACTIONS.REMOVE_ACTION, data);
            }
            else if (ACTIONS.UNION_ACTION in data) {
                (_g = this.yata.persistence) === null || _g === void 0 ? void 0 : _g.addToPeopleQueue(ACTIONS.UNION_ACTION, data);
            }
            else {
                console.error('Invalid call to _enqueue():', data);
            }
        };
        Profile.prototype.union = function (listName, values, callback) {
            if (utils.isObject(listName)) {
                callback = values;
            }
            var data = this.unionAction(listName, values);
            return this.sendRequest(data, callback);
        };
        return Profile;
    }(ApiActions));

    win._yata_error_storage_ = [];
    var overrideWarningAndError = function (consoleType) {
        var oldConsoleLog = window.console[consoleType];
        window.console[consoleType] = function (unsureError) {
            var rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                rest[_i - 1] = arguments[_i];
            }
            try {
                var detail = unsureError;
                if (unsureError === 'Unhandled promise rejection' && rest.length > 0) {
                    var unknownError = rest[0];
                    if (unknownError instanceof Error) {
                        unknownError.message = "unhandled promise rejection " + unknownError.message;
                    }
                    else if (typeof unknownError === 'function') {
                        unknownError = "unhandled promise rejection " + unknownError.toString();
                    }
                    else if (typeof unknownError == 'undefined') {
                        unknownError = "unhandled promise rejection " + String(unknownError);
                    }
                    else {
                        unknownError = "unhandled promise rejection " + JSON.stringify(unknownError);
                    }
                    detail = unknownError;
                }
                var event_1 = new CustomEvent("__console_" + consoleType + "__", {
                    detail: detail
                });
                window.dispatchEvent(event_1);
                win._yata_error_storage_.push(event_1);
            }
            catch (e) {
                //
            }
            var _ = [unsureError].concat(rest);
            oldConsoleLog && oldConsoleLog.apply(this, _);
        };
    };
    // 字符序列化错误对象信息
    var stringifyErrorDetail = function (errorDetail) {
        try {
            if (typeof errorDetail === 'function') {
                return errorDetail.toString();
            }
            else if ('object' !== (typeof errorDetail == 'undefined' ? 'undefined' : (typeof errorDetail))) {
                return String(errorDetail);
            }
            else if (errorDetail === null) {
                return String(errorDetail);
            }
            else {
                return JSON.stringify(errorDetail);
            }
        }
        catch (e) {
            // do nothing
        }
    };
    var tempObj = {};
    var JSError = /** @class */ (function () {
        function JSError(yata) {
            var _this = this;
            // 根据事件类型针对处理各个函数 handler
            this.processSpecError = function (someError) {
                try {
                    if (someError.type === '__console_error__') {
                        _this.handleConsoleError(someError);
                    }
                    else if (someError.type === '__xhr__') {
                        _this.handleXHRError(someError);
                    }
                    else if (someError.type === 'unhandledrejection') {
                        _this.handlePromiseRejection(someError);
                    }
                    else if (someError instanceof ErrorEvent) {
                        _this.handleJsError(someError);
                    }
                    else {
                        _this.handleOtherError(someError);
                    }
                }
                catch (e) {
                    // do nothing
                }
            };
            // 处理 Promise 错误
            this.handlePromiseRejection = function (rejection) {
                var errorInfo = {
                    eventtype: 'error',
                    time: utils.now(),
                    stampid: UUID32()
                };
                if (rejection.reason instanceof Error) { //当拒绝理由为 Error 对象时直接获取
                    errorInfo.message = rejection.reason.message;
                    errorInfo.stack = rejection.reason.stack;
                }
                else {
                    errorInfo.message = stringifyErrorDetail(rejection.reason);
                }
                _this.sendRequest('UNHANDLED_PROMISE_REJECTION', errorInfo, null);
            };
            // 处理 XHR 错误
            this.handleXHRError = function (xhrError) {
                var errorInfo = __assign({ eventtype: 'error', time: utils.now(), stampid: UUID32() }, xhrError.detail);
                _this.sendRequest('XHR_ERROR', errorInfo, null);
            };
            // 冒泡阶段：处理 JS 语法错误，获取堆栈信息，通过中间缓存对象进行标识，相同的错误信息间隔 2s 采一次
            this.handleJsError = function (errorEvent) {
                var errorInfo = {
                    eventtype: 'error',
                    time: utils.now(),
                    stampid: UUID32()
                };
                if (typeof errorEvent === 'string') {
                    errorInfo.message = errorEvent;
                }
                else {
                    var winEvent = window.event;
                    if (!errorEvent.error && !errorEvent.message && winEvent && winEvent.errorMessage) { //ie9 handle
                        errorEvent = {
                            message: winEvent.errorMessage,
                            filename: winEvent.errorUrl,
                            lineno: winEvent.errorLine,
                            colno: winEvent.errorCharacter
                        };
                    }
                    var key = errorEvent.message + "-" + errorEvent.filename + "-" + errorEvent.lineno + "-" + errorEvent.colno;
                    var temp = tempObj[key];
                    tempObj[key] = utils.now();
                    if (temp && utils.now() - temp < 2e3)
                        return;
                    errorInfo.message = errorEvent.message;
                    errorInfo.stack = errorEvent.stack || (errorEvent.error ? errorEvent.error.stack : '');
                    errorInfo.src = errorEvent.filename;
                    errorInfo.line = errorEvent.lineno;
                    errorInfo.col = errorEvent.colno;
                }
                _this.sendRequest('JS_ERROR', errorInfo, null);
            };
            // 捕获阶段：其它错误事件类型，非 ErrorEvent 类型，ie9 无 ErrorEvent API
            // ErrorEvent 事件对象在脚本发生错误时产生，它可以提供发生错误的脚本文件的文件名，以及发生错误时所在的行号等信息
            this.handleOtherError = function (otherError) {
                if ((typeof ErrorEvent === 'undefined' && (otherError instanceof Event)) || !(otherError instanceof ErrorEvent)) {
                    var targetHtml = otherError.target.outerHTML;
                    var path = win.location.href.split('#')[0];
                    if (!!targetHtml && otherError.target.src !== path && !(targetHtml.indexOf('src=""') !== -1 || targetHtml.indexOf('src=\'\'') !== -1)) {
                        var errorInfo = {
                            eventtype: 'error',
                            time: utils.now(),
                            stampid: UUID32(),
                            src: otherError.target.src || otherError.target.href,
                            outerhtml: otherError.target.outerHTML
                        };
                        var originalError = otherError.target.error;
                        if (originalError) {
                            errorInfo.code = originalError.code;
                            errorInfo.message = originalError.message;
                        }
                        _this.sendRequest(otherError.target.tagName.toUpperCase() + "_LOADING_ERROR", errorInfo, null);
                    }
                }
            };
            // 捕获控制台抛错
            this.handleConsoleError = function (consoleError, errorType) {
                try {
                    var errorInfo = {
                        eventtype: 'error',
                        time: utils.now(),
                        stampid: UUID32()
                    };
                    var errorDetail = consoleError.detail;
                    if (errorDetail instanceof Error) {
                        errorInfo.message = errorDetail.message;
                        errorInfo.stack = errorDetail.stack;
                    }
                    else {
                        errorInfo.message = stringifyErrorDetail(errorDetail);
                    }
                    // 做信息过滤处理，防止重复信息污染
                    var key = "" + errorInfo.message;
                    var temp = tempObj[key];
                    tempObj[key] = utils.now();
                    if (temp && utils.now() - temp < 2e3)
                        return;
                    _this.sendRequest('CONSOLE_ERROR', errorInfo, null);
                }
                catch (e) {
                    // do nothing
                }
            };
            this.handleYataError = function () {
            };
            // 针对同步注入的异常对象待异步回调后进行批量处理
            this.processEventTypes = function () {
                if (win._yata_error_storage_ && win._yata_error_storage_.length > 0) {
                    utils.each(win._yata_error_storage_, function (item) {
                        _this.processSpecError(item);
                    });
                }
            };
            // 注入同步事件对象监听
            this.addErrorEventListener = function () {
                try {
                    if (window.addEventListener) {
                        window.addEventListener('unhandledrejection', function (e) {
                            win._yata_error_storage_.push(e);
                        });
                        window.addEventListener('error', function (e) {
                            win._yata_error_storage_.push(e);
                        });
                        window.addEventListener('error', function (e) {
                            try {
                                if (!(e instanceof ErrorEvent)) {
                                    if (e.target && e.target.outerHTML) {
                                        var targetHtml = e.target.outerHTML;
                                        if (!(targetHtml.indexOf('src=""') !== -1 || targetHtml.indexOf('src=\'\'') !== -1)) {
                                            win._yata_error_storage_.push(e);
                                        }
                                    }
                                    else {
                                        win._yata_error_storage_.push(e);
                                    }
                                }
                            }
                            catch (e) {
                                // do nothing
                            }
                        }, true);
                    }
                    else { //ie8
                        var oldonerror_1 = window.onerror;
                        window.onerror = function (message, filename, lineno, colno, error) {
                            win._yata_error_storage_.push({
                                type: 'error',
                                message: message,
                                filename: filename,
                                lineno: lineno,
                                colno: colno,
                                error: error
                            });
                            return oldonerror_1 ? oldonerror_1.apply(window, arguments) : false;
                        };
                    }
                }
                catch (e) {
                    win._yata_error_storage_.push(e);
                }
            };
            this.yata = yata;
            overrideWarningAndError('error');
        }
        // 通过 yata 实例获取配置项参数
        JSError.prototype.getConfig = function (prop) {
            return this.yata.getConfig(prop);
        };
        // 发送异常采集信息
        JSError.prototype.sendRequest = function (eventName, data, callback) {
            var _a, _b, _c;
            // const deviceId = this.yata.getProperty('$device_id');
            // const userId = this.yata.getProperty('$user_id');
            // const hadPersistedDistinctId = this.yata.getProperty('$had_persisted_distinct_id');
            data = data || {};
            data.appid = this.getConfig('app_id');
            data.appname = this.getConfig('app_name');
            var $device_id = ((_a = this.yata.persistence) === null || _a === void 0 ? void 0 : _a.properties()).$device_id;
            var errBlockFlag = false;
            data = utils.extend({
                deviceid: $device_id
            }, Info.properties(), data);
            // 验证可采集的异常类型
            if (((_b = this.getConfig('error_type_block_list')) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                var errorTypeBlockList = this.getConfig('error_type_block_list');
                if (utils.isArray(errorTypeBlockList)) {
                    if (utils.include(errorTypeBlockList, eventName)) {
                        errBlockFlag = true;
                    }
                }
                else {
                    console.error('TYPE-Error -> Invalid value for error_type_block_list config: ' + errorTypeBlockList);
                }
            }
            // 拦截相应的类型错误
            if (errBlockFlag) {
                return;
            }
            return this.yata.trackOrBatch({
                type: 'error',
                data: {
                    event: eventName,
                    properties: data
                },
                endpoint: this.getConfig('api_host') + '/fds/qdcj/errordc',
                batcher: (_c = this.yata.request_batchers) === null || _c === void 0 ? void 0 : _c.error
            }, callback);
        };
        // 注册事件监听
        JSError.prototype.registerErrorHandlers = function () {
            if (win && win.addEventListener) {
                window.addEventListener('error', this.handleJsError);
                window.addEventListener('error', this.handleOtherError, true);
                window.addEventListener('unhandledrejection', this.handlePromiseRejection);
                window.addEventListener('__xhr__', this.handleXHRError);
                window.addEventListener('__console_error__', this.handleConsoleError);
                window.addEventListener('__yata_error__', this.handleYataError);
            }
            else { //ie8 simple implemetion
                var oldonerror_2 = window.onerror;
                var self_1 = this;
                window.onerror = function (message, filename, lineno, colno, error) {
                    self_1.handleJsError({
                        type: 'error',
                        message: message,
                        filename: filename,
                        lineno: lineno,
                        colno: colno,
                        error: error
                    });
                    return oldonerror_2 ? oldonerror_2.apply(window, arguments) : false;
                };
            }
        };
        return JSError;
    }());

    /**
     * Navigation Timing API provides performance metrics for HTML documents.
     * w3c.github.io/navigation-timing/
     * developers.google.com/web/fundamentals/performance/navigation-and-resource-timing
     */
    var getNavigationTiming = function () {
        if (!isPerformanceSupported()) {
            return {};
        }
        // There is an open issue to type correctly getEntriesByType
        // github.com/microsoft/TypeScript/issues/33866
        var n = wp.getEntriesByType('navigation')[0];
        // In Safari version 11.2 Navigation Timing isn't supported yet
        // Safari 不支持时使用向后兼容接口 wp.timing
        if (!n || (Info.browser() === 'Internet Explorer' && Info.browserVersion() < 11)) {
            var wpt = wp.timing;
            // ie < 9
            if (!wpt) {
                return {};
            }
            return {
                timetolastbyte: wpt.responseEnd - wpt.fetchStart,
                reqplusrestime: wpt.responseEnd - wpt.requestStart,
                downloadtime: wpt.responseEnd - wpt.responseStart,
                timetofirstbyte: wpt.responseStart - wpt.fetchStart,
                dnslookuptime: wpt.domainLookupEnd - wpt.domainLookupStart,
                dnslookupcachetime: wpt.domainLookupStart - wpt.fetchStart,
                connect: wpt.connectEnd - wpt.connectStart,
                whitescreen: wpt.domLoading - wpt.navigationStart,
                domreadytime: wpt.domContentLoadedEventEnd - wpt.fetchStart,
                renderdomtime: wpt.loadEventStart - wpt.domContentLoadedEventEnd,
                parsedomtreetime: wpt.domComplete - wpt.domLoading,
                pageloadtotaltime: wpt.loadEventEnd - wpt.navigationStart,
                timetointeracttime: wpt.domInteractive - wpt.navigationStart
            };
        }
        var responseStart = n.responseStart;
        var responseEnd = n.responseEnd;
        // We cache the navigation time for future times
        return {
            // Service worker time plus response time
            // workertime: n.workerStart > 0 ? responseEnd - n.workerStart : 0,
            // HTTP header size HTTP 请求头大小
            // headersize: n.transferSize - n.encodedBodySize || 0,
            // fetchStart marks when the browser starts to fetch a resource
            // responseEnd is when the last byte of the response arrives 首个请求包耗时
            timetolastbyte: responseEnd - n.fetchStart,
            // Time to First Byte (TTFB) 服务端响应首个请求包第一个字节耗时
            timetofirstbyte: responseStart - n.fetchStart,
            // Request plus response time (network only) HTTP 请求+响应耗时
            reqplusrestime: responseEnd - n.requestStart,
            // Response time only (download) 下载耗时
            downloadtime: responseEnd - responseStart,
            // Measuring DNS lookup time DNS查询耗时
            dnslookuptime: n.domainLookupEnd - n.domainLookupStart,
            // 查询 app DNS 缓存耗时
            dnslookupcachetime: n.domainLookupStart - n.fetchStart,
            // TCP 握手时间
            connect: n.connectEnd - n.connectStart,
            // 白屏时间
            whitescreen: wp.timing.domLoading - wp.timing.navigationStart,
            // 首次可交互用时
            timetointeracttime: n.domInteractive - n.fetchStart,
            // DomReady 耗时，各种静态资源已准备完成
            domreadytime: n.domContentLoadedEventEnd - n.fetchStart,
            // 解析 dom 树耗时
            parsedomtreetime: n.domComplete - n.domInteractive,
            // CSSOM 准备完毕后渲染树时长
            renderdomtime: n.loadEventStart - n.domContentLoadedEventEnd,
            //页面全部加载完成耗时
            pageloadtotaltime: n.loadEventEnd - n.startTime
        };
    };

    var et = '4g';
    var sd = false;
    var getNetworkInformation = function () {
        if ('connection' in nav) {
            var dataConnection = nav.connection;
            if (typeof dataConnection !== 'object') {
                return {};
            }
            et = dataConnection.effectiveType;
            sd = !!dataConnection.saveData;
            return {
                downlink: dataConnection.downlink,
                effectiveType: dataConnection.effectiveType,
                rtt: dataConnection.rtt,
                saveData: !!dataConnection.saveData,
            };
        }
        return {};
    };

    var getIsLowEndDevice = function () {
        // If number of logical processors available to run threads <= 4
        if (getHC() && getHC() <= 4) {
            return true;
        }
        // If the approximate amount of RAM client device has <= 4
        if (getDM() && getDM() <= 4) {
            return true;
        }
        return false;
    };
    var getIsLowEndExperience = function (et, sd) {
        // If the effective type of the connection meaning
        // one of 'slow-2g', '2g', '3g', or '4g' is !== 4g
        switch (et) {
            case 'slow-2g':
                return true;
            case '2g':
                return true;
            case '3g':
                return true;
            default:
                // Data Saver preference
                return (getIsLowEndDevice() || sd);
        }
    };

    /**
     * Information coming from window.navigator:
     * 1. Device Memory
     * 2. Hardware Concurency
     * 3. Status of the service worker:
     *     - controlled: a service worker is controlling the page
     *     - supported: the browser supports service worker
     *     - unsupported: the user's browser does not support service worker
     */
    var getNavigatorInfo = function () {
        if (nav) {
            return {
                deviceMemory: getDM() || 0,
                hardwareConcurrency: getHC() || 0,
                serviceWorkerStatus: 'serviceWorker' in nav
                    ? nav.serviceWorker.controller
                        ? 'controlled'
                        : 'supported'
                    : 'unsupported',
                isLowEndDevice: getIsLowEndDevice(),
                isLowEndExperience: getIsLowEndExperience(et, sd)
            };
        }
        return {};
    };

    var visibility = {
        isHidden: false,
    };
    /**
     * From visibilitychange listener it saves only when
     * the page gets hidden, because it's important to not
     * use the wrong "hidden" value when send timing or logging.
     */
    var didVisibilityChange = function (cb) {
        if (doc.hidden) {
            cb();
            visibility.isHidden = doc.hidden;
        }
    };

    var ttfbScore = [200, 500];
    var fcpScore = [2000, 4000];
    var lcpScore = [2500, 4000];
    var fidcore = [100, 300];
    var clsScore = [0.1, 0.25];
    var tbtScore = [300, 600];
    var webVitalsScore = {
        ttfb: ttfbScore,
        fp: fcpScore,
        fcp: fcpScore,
        lcp: lcpScore,
        lcpFinal: lcpScore,
        fid: fidcore,
        cls: clsScore,
        clsFinal: clsScore,
        tbt: tbtScore,
    };
    var getVitalsScore = function (measureName, value) {
        if (!webVitalsScore[measureName]) {
            return null;
        }
        if (value <= webVitalsScore[measureName][0]) {
            return 'good';
        }
        return value <= webVitalsScore[measureName][1] ? 'needsImprovement' : 'poor';
    };

    /**
     * Sends the User timing measure to perfTracker
     */
    var reportPerf = function (measureName, data, customProperties) {
        pushTask(function () {
            // Doesn't send timing when page is hidden
            if ((visibility.isHidden && measureName.indexOf('Final') < 0) ||
                !perfCONFIG.perfTracker) {
                return;
            }
            // Send metric to custom Analytics service
            perfCONFIG.perfTracker({
                metricName: measureName,
                data: data,
                eventProperties: customProperties || {},
                navigatorInformation: getNavigatorInfo(),
                vitalsScore: getVitalsScore(measureName, data),
            });
        });
    };

    var logData = function (measureName, metric, customProperties) {
        if (typeof metric !== 'number') {
            Object.keys(metric).forEach(function (key) {
                if (typeof metric[key] === "number") {
                    metric[key] = roundByFour(metric[key]);
                }
            });
        }
        // Sends the metric to an external tracking service
        reportPerf(measureName, metric, customProperties);
    };
    /**
     * Dispatches the metric duration into internal logs
     * and the external time tracking service.
     */
    var logMetric = function (duration, measureName, customProperties) {
        var duration2Decimal = roundByFour(duration);
        if (duration2Decimal <= perfCONFIG.maxTime && duration2Decimal >= 0) {
            // Sends the metric to an external tracking service
            reportPerf(measureName, duration2Decimal, customProperties);
        }
    };

    /**
     * Get the duration of the timing metric or -1
     * if there a measurement has not been made by the User Timing API
     */
    var performanceMeasure = function (measureName) {
        wp.measure(measureName, "mark_" + measureName + "_start", "mark_" + measureName + "_end");
        var entry = wp.getEntriesByName(measureName).pop();
        if (entry && entry.entryType === 'measure') {
            return entry.duration;
        }
        return -1;
    };

    var metrics = {};
    var cls = {
        value: 0,
    };
    var fcp = {
        value: 0,
    };
    var lcp = {
        value: 0,
    };
    var fcpEntryName = 'first-contentful-paint';
    var rt = {
        value: {
            beacon: 0,
            css: 0,
            fetch: 0,
            img: 0,
            other: 0,
            script: 0,
            total: 0,
            xmlhttprequest: 0,
        },
    };
    var tbt = {
        value: 0,
    };

    /**
     * Detects new layout shift occurrences and updates the
     * `cumulativeLayoutShiftScore` variable.
     */
    var initLayoutShift = function (performanceEntries) {
        var lastEntry = performanceEntries.pop();
        // Only count layout shifts without recent user input.
        if (lastEntry && !lastEntry.hadRecentInput && lastEntry.value) {
            cls.value += lastEntry.value;
        }
    };

    var perfObservers = {};

    /**
     * PerformanceObserver subscribes to performance events as they happen
     * and respond to them asynchronously.
     */
    var po = function (eventType, cb) {
        try {
            var perfObserver = new PerformanceObserver(function (entryList) {
                cb(entryList.getEntries());
            });
            // Retrieve buffered events and subscribe to newer events for Paint Timing
            perfObserver.observe({ type: eventType, buffered: true });
            return perfObserver;
        }
        catch (e) {
            console$1.warn(e);
        }
        return null;
    };
    var poDisconnect = function (observer) {
        if (perfObservers[observer]) {
            perfObservers[observer].disconnect();
        }
        delete perfObservers[observer];
    };

    var initFirstInputDelay = function (performanceEntries) {
        var lastEntry = performanceEntries.pop();
        if (lastEntry) {
            // Core Web Vitals FID logic
            // Measure the delay to begin processing the first input event
            logMetric(lastEntry.processingStart - lastEntry.startTime, 'fid', {
                performanceEntry: lastEntry
            });
        }
        // Disconnect this observer since callback is only triggered once
        poDisconnect(1);
        logMetric(lcp.value, 'lcp');
        if (perfObservers[3] && typeof perfObservers[3].takeRecords === 'function') {
            perfObservers[3].takeRecords();
        }
        logMetric(cls.value, 'cls');
        // TBT has 10 second delay after FID
        setTimeout(function () {
            logMetric(tbt.value, "tbt");
            logData('dataConsumption', rt.value);
        }, 10000);
    };

    var initTotalBlockingTime = function (performanceEntries) {
        performanceEntries.forEach(function (entry) {
            if (entry.name !== 'self' ||
                entry.startTime < fcp.value) {
                return;
            }
            var blockingTime = entry.duration - 50;
            if (blockingTime > 0) {
                tbt.value += blockingTime;
            }
        });
    };

    /**
     * First Paint is essentially the paint after which
     * the biggest above-the-fold layout change has happened.
     */
    var initFirstPaint = function (performanceEntries) {
        performanceEntries.forEach(function (entry) {
            if (entry.name === 'first-paint') {
                logMetric(entry.startTime, 'fp');
            }
            else if (entry.name === fcpEntryName) {
                fcp.value = entry.startTime;
                logMetric(fcp.value, 'fcp');
                perfObservers[4] = po('longtask', initTotalBlockingTime);
                poDisconnect(0);
            }
        });
    };
    var initLargestContentfulPaint = function (performanceEntries) {
        var lastEntry = performanceEntries.pop();
        if (lastEntry) {
            lcp.value = lastEntry.renderTime || lastEntry.loadTime;
        }
    };
    var initElementTiming = function (performanceEntries) {
        performanceEntries.forEach(function (entry) {
            if (entry.identifier) {
                logMetric(entry.startTime, entry.identifier);
            }
        });
    };

    var initResourceTiming = function (performanceEntries) {
        performanceEntries.forEach(function (entry) {
            if (perfCONFIG.isResourceTiming) {
                logData('resourceTiming', entry);
            }
            if (entry.decodedBodySize && entry.initiatorType) {
                var bodySize = entry.decodedBodySize / 1000;
                rt.value[entry.initiatorType] += bodySize;
                rt.value.total += bodySize;
            }
        });
    };

    var initPerformanceObserver = function () {
        perfObservers[0] = po('paint', initFirstPaint);
        // FID needs to be initialized as soon as Perfume is available
        // DataConsumption resolves after FID is triggered
        perfObservers[1] = po('first-input', initFirstInputDelay);
        perfObservers[2] = po('largest-contentful-paint', initLargestContentfulPaint);
        // Collects KB information related to resources on the page
        if (perfCONFIG.isResourceTiming) {
            po('resource', initResourceTiming);
        }
        perfObservers[3] = po('layout-shift', initLayoutShift);
        if (perfCONFIG.isElementTiming) {
            po('element', initElementTiming);
        }
    };
    var disconnectPerfObserversHidden = function () {
        if (perfObservers[2]) {
            logMetric(lcp.value, "lcpFinal");
            poDisconnect(2);
        }
        if (perfObservers[3]) {
            if (typeof perfObservers[3].takeRecords === 'function') {
                perfObservers[3].takeRecords();
            }
            logMetric(cls.value, "clsFinal");
            poDisconnect(3);
        }
    };

    /**
     * The estimate() method of the StorageManager interface asks the Storage Manager
     * for how much storage the app takes up (usage),
     * and how much space is available (quota).
     */
    var reportStorageEstimate = function (storageInfo) {
        var estimateUsageDetails = 'usageDetails' in storageInfo ? storageInfo.usageDetails : {};
        logData('storageEstimate', {
            quota: convertToKB(storageInfo.quota),
            usage: convertToKB(storageInfo.usage),
            caches: convertToKB(estimateUsageDetails.caches),
            indexedDB: convertToKB(estimateUsageDetails.indexedDB),
            serviceWorker: convertToKB(estimateUsageDetails.serviceWorkerRegistrations),
        });
    };

    var Perf = /** @class */ (function () {
        function Perf(yata) {
            this.yata = yata;
        }
        // initialize func
        Perf.prototype.init = function (options) {
            if (options === void 0) { options = {}; }
            // Extend default config with external options
            perfCONFIG.perfTracker = options.perfTracker;
            perfCONFIG.isResourceTiming = !!options.resourceTiming;
            perfCONFIG.isElementTiming = !!options.elementTiming;
            perfCONFIG.maxTime = options.maxMeasureTime || perfCONFIG.maxTime;
            // Exit from Perfume when basic Web Performance APIs aren't supported
            if (!isPerformanceSupported()) {
                return;
            }
            // Checks if use Performance or the EmulatedPerformance instance
            if ('PerformanceObserver' in win) {
                initPerformanceObserver();
            }
            // Init visibilitychange listener
            if (typeof doc.hidden !== 'undefined') {
                // Opera 12.10 and Firefox 18 and later support
                doc.addEventListener('visibilitychange', didVisibilityChange.bind(this, disconnectPerfObserversHidden));
            }
            var navigationTiming = getNavigationTiming();
            // Log Navigation Timing
            logData('navigationTiming', navigationTiming);
            if (navigationTiming.timetofirstbyte) {
                logMetric(navigationTiming.timetofirstbyte, 'ttfb');
            }
            // Log Network Information
            logData('networkInformation', getNetworkInformation());
            // Let's estimate our storage capacity
            if (nav && nav.storage && typeof nav.storage.estimate === 'function') {
                nav.storage.estimate().then(reportStorageEstimate);
            }
        };
        // 发送性能检测指标
        Perf.prototype.sendRequest = function (eventName, data, callback) {
            var _a, _b;
            data = data || {};
            data.appid = this.yata.getConfig('app_id');
            data.appname = this.yata.getConfig('app_name');
            var $device_id = ((_a = this.yata.persistence) === null || _a === void 0 ? void 0 : _a.properties()).$device_id;
            data = utils.extend({
                eventtype: 'perf',
                deviceid: $device_id,
            }, Info.properties(), data);
            // delete referrer 
            if (data.hasOwnProperty('referrer')) {
                delete data["referrer"];
            }
            this.yata.trackOrBatch({
                type: 'perf',
                data: {
                    event: eventName,
                    properties: data
                },
                endpoint: this.yata.getConfig('api_host') + '/fds/qdcj/perfdc',
                batcher: (_b = this.yata.request_batchers) === null || _b === void 0 ? void 0 : _b.perf
            }, callback);
        };
        // Bootstrap performance monitor behavior
        Perf.prototype.startPerformanceTrack = function () {
            var _this = this;
            var resCollections = [];
            this.init({
                resourceTiming: this.yata.getConfig('resourceTiming'),
                perfTracker: function (options) {
                    var metricName = options.metricName, data = options.data;
                    switch (metricName) {
                        case "navigationTiming":
                            if (data && (data.timetofirstbyte || data.timetolastbyte)) {
                                _this.sendRequest('NAVIGATION_TIME', data, null);
                            }
                            break;
                        case "resourceTiming":
                            if (data && data.entryType === "resource") {
                                var resourceData = {
                                    duration: data.duration,
                                    name: data.name,
                                    type: data.initiatorType,
                                    bodysize: data.encodedBodySize,
                                };
                                if (resCollections.length < _this.yata.getConfig('resource_request_size')) {
                                    // 过滤黑名单
                                    var isNotResBlackList = ["livereload.js", "/fds/qdcj"].every(function (item) { return data.name.indexOf(item) === -1; });
                                    // 去重
                                    var isNotDuplication = resCollections.every(function (cur) { return data.name !== cur.resName; });
                                    if (isNotResBlackList && isNotDuplication) {
                                        resCollections.push(resourceData);
                                    }
                                }
                                else {
                                    var data_1 = {
                                        resData: resCollections,
                                    };
                                    _this.sendRequest("RESOURCE_DATA", data_1, function () {
                                        resCollections = [];
                                    });
                                }
                                // console.log(resCollections.length, resCollections, data);
                            }
                            break;
                        default:
                            if (utils.includes(metricName, 'perf-')) {
                                var measureData = {
                                    duration: data
                                };
                                _this.sendRequest(metricName, measureData, null);
                            }
                            break;
                    }
                },
            });
        };
        /**
         * Start performance measurement
         */
        Perf.prototype.start = function (markName) {
            if (!isPerformanceSupported() || metrics[markName]) {
                return;
            }
            metrics[markName] = true;
            // Creates a timestamp in the browser's performance entry buffer
            wp.mark("mark_" + markName + "_start");
            // Reset hidden value
            visibility.isHidden = false;
        };
        /**
         * End performance measurement
         */
        Perf.prototype.end = function (markName, customProperties) {
            if (customProperties === void 0) { customProperties = {}; }
            if (!isPerformanceSupported() || !metrics[markName]) {
                return;
            }
            // End Performance Mark
            wp.mark("mark_" + markName + "_end");
            delete metrics[markName];
            logData(markName, roundByFour(performanceMeasure(markName)), customProperties);
        };
        /**
         * End performance measurement after first paint from the beging of it
         */
        Perf.prototype.endPaint = function (markName, customProperties) {
            var _this = this;
            setTimeout(function () {
                _this.end(markName, customProperties);
            });
        };
        /**
         * Removes the named mark from the browser's performance entry buffer.
         */
        Perf.prototype.clear = function (markName) {
            delete metrics[markName];
            // Mobile Safari v13 and UC Browser v11
            // don't support clearMarks yet
            if (!wp.clearMarks) {
                return;
            }
            wp.clearMarks("mark_" + markName + "_start");
            wp.clearMarks("mark_" + markName + "_end");
        };
        // 开启性能监测功能
        Perf.prototype.registerPerfHandler = function () {
            var _this = this;
            if (this.yata.getConfig('api_transport') === 'NATIVE') { // 针对 Cordova 环境监听处理
                doc.addEventListener && doc.addEventListener('deviceready', function () {
                    setTimeout(function () {
                        _this.startPerformanceTrack();
                    }, 0);
                });
            }
            else {
                win.addEventListener && win.addEventListener('load', function () {
                    setTimeout(function () {
                        _this.startPerformanceTrack();
                    }, 0);
                });
            }
        };
        return Perf;
    }());

    var IDENTITY_FUNC = function IDENTITY_FUNC(x) {
        return x;
    };
    var NOOP_FUNC = function NOOP_FUNC() {
    };
    // const EVENT_TYPE = ['pv', 'click', 'error', 'dwell', 'perf', 'sdkEvent'];
    var MAIN_LOG;
    var PRIMARY_INSTANCE_NAME = 'YATA';
    //检测 IE8 ~ 9/IE10及以上
    var USE_XHR = ((window.XMLHttpRequest && 'withCredentials' in new XMLHttpRequest()) || !!window.XMLHttpRequest || 'XDomainRequest' in window);
    var ENQUEUE_REQUESTS = !USE_XHR && (userAgent.indexOf('MSIE') === -1) && (userAgent.indexOf('Mozilla') === -1);
    // 重命名navigator.sendBeacon，使之可以被minified
    var sendBeacon = null;
    if (nav.sendBeacon) {
        sendBeacon = nav.sendBeacon;
    }
    var REGISTER_DEFAULTS = {
        persistent: true
    };
    // 合并默认注册项及传入的对象参数，在于配置过期日期 days 给本地 cookie/storage
    var optionsForRegister = function (daysOrOptions) {
        var options;
        if (utils.isObject(daysOrOptions)) {
            options = daysOrOptions;
        }
        else if (!utils.isUndefined(daysOrOptions)) {
            options = {
                days: daysOrOptions
            };
        }
        else {
            options = {};
        }
        return utils.extend({}, REGISTER_DEFAULTS, options);
    };
    // 编码上报数据，结构分为通用字段及 data 业务字段，当进行上报时 payload 数据
    var encodeDataForRequest = function (data) {
        var requestData;
        if (Info.os() === 'iOS' || Info.os() === 'Android') { // mobile
            requestData = {
                appid: data[0].properties.appid,
                appname: data[0].properties.appname,
                sdkversion: data[0].properties.sdkversion,
                deviceid: data[0].properties.deviceid,
                devicepixelratio: data[0].properties.devicepixelratio,
                vendor: data[0].properties.vendor,
                system: data[0].properties.system,
                sendnetwork: data[0].properties.sendnetwork,
                pageid: data[0].properties.pageid,
                screenwidth: data[0].properties.screenwidth,
                screenheight: data[0].properties.screenheight,
                platform: data[0].properties.platform,
                platformversion: data[0].properties.platformversion,
                sendtime: utils.now()
            };
        }
        else { // web
            requestData = {
                appid: data[0].properties.appid,
                appname: data[0].properties.appname,
                sdkversion: data[0].properties.sdkversion,
                deviceid: data[0].properties.deviceid,
                devicepixelratio: data[0].properties.devicepixelratio,
                system: data[0].properties.system,
                pageid: data[0].properties.pageid,
                screenwidth: data[0].properties.screenwidth,
                screenheight: data[0].properties.screenheight,
                browser: data[0].properties.browser,
                browserversion: data[0].properties.browserversion,
                sendtime: utils.now()
            };
        }
        // 基础公共字段
        var METADATA = ['appid', 'appname', 'sdkversion', 'deviceid', 'devicepixelratio',
            'vendor', 'system', 'sendnetwork', 'pageid', 'operator', 'screenwidth',
            'screenheight', 'platform', 'platformversion', 'browser', 'browserversion', 'sendtime'];
        // 删除 property_block_list 指定的全局公共字段，去除上报字段
        utils.each(requestData, function (v, k) {
            if (utils.isUndefined(v)) {
                delete requestData[k];
            }
        });
        // 增加 data 字段，并剔除公共请求字段，即内部包裹的事件类型请求字段结果
        requestData.data = utils.map(data, function (item) {
            utils.each(METADATA, function (key) {
                delete item.properties[key];
            });
            return __assign({ eventid: item.event }, item.properties);
        });
        console$1.log('[batch]REAL YATA REQUEST: ', requestData);
        var jsonData = JSONStringify(requestData);
        var encodedData = Base64.encode(jsonData);
        return {
            data: encodedData
        };
    };
    var Yata = /** @class */ (function () {
        function Yata() {
            this.cached_groups = {};
            this.user_decide_check_complete = false;
            this.events_tracked_before_user_decide_check_complete = [];
        }
        Yata.prototype.init = function (app_id, name, config) {
            var _this = this;
            if (name === void 0) { name = PRIMARY_INSTANCE_NAME; }
            config = config || {};
            this.__loaded = true;
            this.config = {};
            this._triggered_notify = [];
            var variable_features = {};
            var api_host = config.api_host;
            var is_custom_api = !!api_host && !api_host.match(/\.yata\.com$/);
            if (!('batch_requests' in config) && !is_custom_api) {
                variable_features.batch_requests = true;
            }
            this.setConfig(utils.extend({}, DEFAULT_CONFIG, variable_features, config, {
                app_id: app_id,
                app_name: name,
                callback_fn: (name === PRIMARY_INSTANCE_NAME ? name : PRIMARY_INSTANCE_NAME + '.' + name) + '._jsc'
            }));
            this._jsc = NOOP_FUNC;
            this.__dom_loaded_queue = [];
            this.__request_queue = [];
            this.__disabled_events = [];
            this.flag = {
                disable_all_events: false,
                identify_called: false
            };
            this.allow_upload = false;
            this.request_batchers = {};
            // 鉴权
            var auth_default_params = { pureRequest: true };
            var auth_ext_params = this.getConfig('auth_params') || {};
            this.sendRequest(this.getConfig('api_host') + '/fds/qdcj/check', utils.extend(auth_default_params, auth_ext_params), { method: 'GET', verbose: true }, this.prepareCallback(function (resp) {
                var _a, _b;
                if (resp.code === 'SUCCESS') {
                    if (resp.data['allow']) {
                        _this.allow_upload = true;
                        // 是否开启批量发送 boolean
                        _this._batch_requests = _this.getConfig('batch_requests');
                        if (_this._batch_requests) {
                            if (!localStorageSupported(undefined, true) || !USE_XHR) {
                                _this._batch_requests = false;
                                console$1.log('Turning off Yata request-queueing. needs XHR and localStorage support');
                            }
                            else {
                                // 根据接口状态判断是否默认需要行为处理器
                                if (utils.isUndefined(resp.data['allowDcCollection'])) {
                                    _this.initBatchers(true);
                                }
                                else if (!resp.data['allowDcCollection']) {
                                    _this.initBatchers(false);
                                }
                                else {
                                    _this.initBatchers(true);
                                }
                                // 高级浏览器 unload 时上报行为采集
                                if (sendBeacon && win.addEventListener) {
                                    win.addEventListener('unload', function () {
                                        if (_this.request_batchers && _this.request_batchers.events && !_this.request_batchers.events.stopped) {
                                            _this.request_batchers.events.flush({ unloading: true });
                                        }
                                    });
                                }
                                // 过滤异常类别处理
                                if (((_a = resp.data['errorTypeFilterList']) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                                    var errorTypeBlockList = resp.data['errorTypeFilterList'].split(',');
                                    var pureList_1 = [];
                                    // 合并初始配置项
                                    if (((_b = _this.getConfig('error_type_block_list')) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                                        errorTypeBlockList = errorTypeBlockList.concat(_this.getConfig('error_type_block_list'));
                                    }
                                    utils.each(errorTypeBlockList, function (val) {
                                        pureList_1.push(utils.trim(val)); // 清除出现前后空格符
                                    });
                                    _this.setConfig({
                                        'error_type_block_list': pureList_1
                                    });
                                }
                                // 通过接口字段来控制是否采集异常
                                if (utils.isUndefined(resp.data['allowErrorCollection'])) {
                                    if (_this.getConfig('report_errors')) {
                                        _this.errorHandler.processEventTypes();
                                        _this.errorHandler.registerErrorHandlers();
                                    }
                                }
                                else if (resp.data['allowErrorCollection']) {
                                    _this.errorHandler.processEventTypes();
                                    _this.errorHandler.registerErrorHandlers();
                                }
                            }
                        }
                    }
                }
            }, null));
            // TODO: set persistence instance
            this.persistence = this.cookie = new Persistence(this.config);
            this.unpersisted_superprops = {};
            // TODO: The General Data Protection Regulation (GDPR) init
            // this.gdprInit();
            var uuid = UUID();
            if (!this.getDistinctID()) {
                this.registerOnce({
                    'distinct_id': uuid,
                    '$device_id': uuid
                }, '');
            }
            this.profile = new Profile(MAIN_LOG);
            // 是否开启异常监控
            this.errorHandler = new JSError(MAIN_LOG);
            if (this.getConfig('report_errors')) {
                this.errorHandler.addErrorEventListener();
            }
            // 是否开启性能监控
            if (this.getConfig('use_perf')) {
                this.perfInstance = new Perf(MAIN_LOG);
                this.perfInstance.registerPerfHandler();
            }
        };
        // 正式发起上报请求，各种兼容处理，☆☆核心函数☆☆
        Yata.prototype.sendRequest = function (url, data, options, callback) {
            var _a, _b, _c, _d, _e, _f, _g;
            var succeeded = true;
            // 这是什么环境下？Opera
            if (ENQUEUE_REQUESTS) {
                (_a = this.__request_queue) === null || _a === void 0 ? void 0 : _a.push(arguments);
                return succeeded;
            }
            // 默认参数，从初始化配置项中获取
            var DEFAULT_OPTIONS = {
                method: this.getConfig('api_method'),
                transport: this.getConfig('transport'),
                verbose: this.getConfig('verbose')
            };
            var bodyData = null;
            if (!callback && (utils.isFunction(options) || typeof options === 'string')) { // 形参位置调整
                callback = options;
                options = undefined;
            }
            options = utils.extend(DEFAULT_OPTIONS, options || {}); // 合并 options 选项
            // 不支持 XHR 环境下使用 Get 类型
            if (!USE_XHR) {
                options.method = 'GET';
            }
            var use_post = options.method === 'POST';
            var use_sendBeacon = sendBeacon && use_post && ((_b = options.transport) === null || _b === void 0 ? void 0 : _b.toLowerCase()) === 'send_beacon';
            // Cordova 环境
            var use_native = !!((_e = (_d = (_c = win === null || win === void 0 ? void 0 : win.cordova) === null || _c === void 0 ? void 0 : _c.plugins) === null || _d === void 0 ? void 0 : _d.http) === null || _e === void 0 ? void 0 : _e.sendRequest) && ((_f = options.transport) === null || _f === void 0 ? void 0 : _f.toLowerCase()) === 'native';
            if (((_g = this.getConfig('api_transport')) === null || _g === void 0 ? void 0 : _g.toLowerCase()) === 'native') {
                use_native = true;
            }
            // 若数据中含有冗长模式时强制使用
            var verbose_mode = options.verbose;
            if (data.verbose) {
                verbose_mode = true;
            }
            // test 是在数据做分析时用来订正垃圾数据的吗？
            if (this.getConfig('test')) {
                data.test = 1;
            }
            // 与上面逻辑同理，若设置为冗长提示模式，则给 data 数据中打标识
            if (this.getConfig('verbose')) {
                data.verbose = 1;
            }
            // 标注图片方式，除纯请求外
            if (this.getConfig('img') && !data.pureRequest) {
                data.img = 1;
            }
            // 不支持 XHR 时，提供 callback 时则给 data 标识，否则判断是否有冗长模式或 test 时则赋予空函数表达式
            if (!USE_XHR) {
                if (callback) {
                    data.callback = callback;
                }
                else if (verbose_mode || this.getConfig('test')) {
                    data.callback = '(function(){})';
                }
            }
            if (this.getConfig('ip')) {
                data.ip = 1;
            }
            data._ = utils.now().toString(); //每次请求注入的时间戳标志
            // 使用 Post 类型时给数据编码处理，留下编码后数据，删除原数据 data 结构中不存在
            if (use_post) {
                bodyData = data.data;
                if (!data.img) { // 非创建图片上报时
                    delete data.data;
                }
                // 针对 ie(8/9/10)等浏览器中无法携带请求头字段问题，通过参数形式fixed;
                if (Info.browser() === 'Internet Explorer' && Info.browserVersion() < 11) {
                    data.encrypt = 'base64';
                }
            }
            url += '?' + QueryStringify(data); // 转换拼接 url 参数
            if ('img' in data) { // 优先用图片发起上报请求
                var img = doc.createElement('img');
                img.src = url;
                document.body.appendChild(img);
            }
            else if (use_sendBeacon) { // 其次采用 sendBeacon 形式
                try {
                    succeeded = nav.sendBeacon(url, bodyData);
                }
                catch (e) {
                    console$1.error(e);
                    succeeded = false;
                }
                try {
                    if (callback) {
                        callback(succeeded ? 1 : 0);
                    }
                }
                catch (e) {
                    console$1.error(e);
                }
            }
            else if (use_native) { // 再次于 Cordova 环境下
                var headersOptions = this.getConfig('xhr_headers') || {};
                win.cordova.plugins.http.sendRequest(url, {
                    method: options.method,
                    data: bodyData,
                    serializer: 'utf8',
                    headers: headersOptions,
                }, function (res) {
                    if (callback) {
                        var response = void 0;
                        try {
                            response = JSONParse(res.data);
                        }
                        catch (e) {
                            console$1.error(e);
                            if (options.ignore_json_errors) { // raw 输出
                                response = res.data;
                            }
                            else {
                                return;
                            }
                        }
                        callback(response);
                    }
                }, function () {
                });
            }
            else if (USE_XHR) { // 这时使用 XHR
                try {
                    var startTime_1;
                    var useXDomainRequest = 'XDomainRequest' in win; // ie8~9
                    var req_1 = useXDomainRequest ? new win.XDomainRequest() : new XMLHttpRequest();
                    req_1.open(options.method, url, true);
                    if (options.timeout_ms && typeof req_1.timeout != 'undefined') {
                        req_1.timeout = options.timeout_ms; // 设置超时时长
                        startTime_1 = utils.now();
                    }
                    req_1.withCredentials = false;
                    if (useXDomainRequest) {
                        req_1.onload = function () {
                            if (callback) {
                                if (verbose_mode) {
                                    var response = void 0;
                                    try {
                                        response = JSONParse(req_1.responseText);
                                    }
                                    catch (e) {
                                        console$1.error(e);
                                        if (options.ignore_json_errors) {
                                            response = req_1.responseText;
                                        }
                                        else {
                                            return;
                                        }
                                    }
                                    callback(response);
                                }
                                else {
                                    callback(req_1.responseText); // 非冗长模式返回code码
                                }
                            }
                        };
                        req_1.onerror = function () {
                            var error;
                            if (req_1.timeout && !req_1.status && utils.now() - startTime_1 >= req_1.timeout) { // 超时
                                error = 'timeout';
                            }
                            else {
                                error = 'Bad HTTP status: ' + req_1.status + ' ' + req_1.statusText;
                            }
                            console$1.error(error);
                            if (callback) {
                                if (verbose_mode) {
                                    callback({
                                        status: 0,
                                        error: error,
                                        xhr_req: req_1
                                    });
                                }
                                else {
                                    callback(0);
                                }
                            }
                        };
                        req_1.onprogress = NOOP_FUNC;
                    }
                    else {
                        req_1.onreadystatechange = function () {
                            if (req_1.readyState === 4) {
                                if (req_1.status === 200) {
                                    if (callback) {
                                        if (verbose_mode) {
                                            var response = void 0;
                                            try {
                                                response = JSONParse(req_1.responseText);
                                            }
                                            catch (e) {
                                                console$1.error(e);
                                                if (options.ignore_json_errors) {
                                                    response = req_1.responseText;
                                                }
                                                else {
                                                    return;
                                                }
                                            }
                                            callback(response);
                                        }
                                        else {
                                            callback(req_1.responseText); // 非冗长模式返回code码
                                        }
                                    }
                                }
                                else {
                                    var error = void 0;
                                    if (req_1.timeout && !req_1.status && utils.now() - startTime_1 >= req_1.timeout) { // 超时
                                        error = 'timeout';
                                    }
                                    else {
                                        error = 'Bad HTTP status: ' + req_1.status + ' ' + req_1.statusText;
                                    }
                                    console$1.error(error);
                                    if (callback) {
                                        if (verbose_mode) {
                                            callback({
                                                status: 0,
                                                error: error,
                                                xhr_req: req_1
                                            });
                                        }
                                        else {
                                            callback(0);
                                        }
                                    }
                                }
                            }
                        };
                    }
                    if (use_post) { // Post 时设置请求头对象
                        var headers = this.getConfig('xhr_headers');
                        // headers['Content-Type'] = 'application/json;charset=UTF-8';
                        headers['Content-Type'] = 'text/plain;charset=UTF-8';
                        if (headers && !useXDomainRequest) {
                            utils.each(headers, function (headerValue, headerName) {
                                req_1.setRequestHeader(headerName, headerValue);
                            });
                        }
                        req_1.send(bodyData);
                    }
                    else {
                        req_1.send();
                    }
                }
                catch (e) {
                    console$1.error(e);
                    succeeded = false;
                }
            }
            else { // 最后采用 JSONP
                var script = doc.createElement('script');
                script.type = 'text/javascript';
                script.async = true;
                script.defer = true;
                script.src = url;
                var s = doc.getElementsByTagName('script')[0];
                s.parentNode && s.parentNode.insertBefore(script, s);
            }
            return succeeded;
        };
        // 预处理 xhr 及 jsonp 等形式的回调函数？？？
        Yata.prototype.prepareCallback = function (callback, data) {
            if (utils.isUndefined(callback)) {
                return null;
            }
            if (USE_XHR) {
                return function (response) { return callback(response, data); };
            }
            else {
                var jsc_1 = this._jsc;
                var randomizedCallback_1 = '' + Math.floor(Math.random() * 100000000);
                var callbackString = this.getConfig('callback_fn') + '[' + randomizedCallback_1 + ']';
                jsc_1[randomizedCallback_1] = function (response) {
                    delete jsc_1[randomizedCallback_1];
                    callback(response, data);
                };
                return callbackString;
            }
        };
        // 数据上报前的钩子处理函数，可以进行数据修改，type(events/error)
        Yata.prototype.runHook = function (hookName, payload) {
            var _a;
            var hook = ((_a = this.config) === null || _a === void 0 ? void 0 : _a.hooks[hookName]) || IDENTITY_FUNC;
            var ret = hook.apply(this, [payload]);
            if (typeof ret === 'undefined') {
                console$1.error(hookName + ' hook did not return a value');
                ret = null;
            }
            return ret;
        };
        // 验证是否已初始化批量处理器实例
        Yata.prototype.areBatchersInitialized = function () {
            return utils.keys(this.request_batchers).length > 0;
        };
        // 初始化批量处理器
        Yata.prototype.initBatchers = function (isNeedDefaultBatcher) {
            var _this = this;
            var token = this.getConfig('app_id');
            if (!this.areBatchersInitialized()) { //未初始化时
                // 批量器初始化专用表达式
                var batcherFor = function (attrs) {
                    return new RequestBatcher('__je_' + token + attrs.queue_suffix, {
                        libConfig: _this.config,
                        sendRequestFunc: function (data, options, cb) {
                            _this.sendRequest(_this.getConfig('api_host') + attrs.endpoint, encodeDataForRequest(data), options, _this.prepareCallback(cb, data));
                        },
                        beforeSendHook: function (item) {
                            return _this.runHook('before_send_' + attrs.type, item);
                        }
                    });
                };
                // 请求批量处理器集合
                if (isNeedDefaultBatcher) {
                    this.request_batchers = {
                        events: batcherFor({ type: 'events', endpoint: '/fds/qdcj/dc', queue_suffix: '_ev' })
                    };
                }
                else {
                    this.request_batchers = {};
                }
                // 是否开启异常批量处理器实例化
                if (this.getConfig('report_errors')) {
                    var errorBatcher = { error: batcherFor({ type: 'error', endpoint: '/fds/qdcj/errordc', queue_suffix: '_err' }) };
                    utils.extend(this.request_batchers, errorBatcher);
                }
                // 是否开启性能批量处理器实例化
                if (this.getConfig('use_perf')) {
                    var perfBatcher = { perf: batcherFor({ type: 'perf', endpoint: '/fds/qdcj/perfdc', queue_suffix: '_perf' }) };
                    utils.extend(this.request_batchers, perfBatcher);
                }
            }
            // 是否自动执行批量处理
            if (this.getConfig('batch_auto_start')) {
                this.startBatchSenders();
            }
        };
        // 开始执行批处理器，同时置状态为 true
        Yata.prototype.startBatchSenders = function () {
            if (this.areBatchersInitialized()) {
                this._batch_requests = true;
                utils.each(this.request_batchers, function (batcher) {
                    batcher.start();
                });
            }
        };
        Yata.prototype.setConfig = function (config) {
            if (utils.isObject(config)) {
                utils.extend(this.config, config);
            }
            var newBatchSize = config.batch_size;
            if (newBatchSize) {
                utils.each(this.request_batchers, function (batcher) {
                    batcher.resetBatchSize();
                });
            }
            if (!this.getConfig('persistence_name')) {
                this.config.persistence_name = this.config.cookie_name;
            }
            if (!this.getConfig('disable_persistence')) {
                this.config.disable_persistence = this.config.disable_cookie;
            }
            if (this.persistence) ;
            CONFIG.DEBUG = CONFIG.DEBUG || this.getConfig('debug');
        };
        Yata.prototype.getConfig = function (propName) {
            return this.config[propName];
        };
        Yata.prototype.getProperty = function (propName) {
            var _a;
            return (_a = this.persistence) === null || _a === void 0 ? void 0 : _a.props[propName];
        };
        Yata.prototype.getDistinctID = function () {
            return this.getProperty('distinct_id');
        };
        Yata.prototype.addGroup = function (groupKey, groupId, callback) {
            var _a;
            var oldValues = this.getProperty(groupKey);
            var prop = {};
            if (oldValues == undefined) {
                prop[groupKey] = [groupId];
                this.register(prop);
            }
            else {
                if (Array.isArray(oldValues) && oldValues.indexOf(groupId) === -1) {
                    oldValues.push(groupId);
                    this.register(prop);
                }
            }
            return (_a = this.profile) === null || _a === void 0 ? void 0 : _a.union(groupKey, groupId, callback);
        };
        /**
         * 注册一组通用属性，在之后的每个事件中都将带上这一组属性，多次调用该方法会覆盖之前注册的属性值
         * */
        Yata.prototype.register = function (props, daysOrOptions) {
            var _a;
            var options = optionsForRegister(daysOrOptions);
            if (options.persistent) {
                (_a = this.persistence) === null || _a === void 0 ? void 0 : _a.register(props, options.days);
            }
            else {
                utils.extend(this.unpersisted_superprops, props);
            }
        };
        /**
         * 注册一组通用属性，在之后的每个事件中都将带上这一组属性，可以多次调用，该方法不会覆盖之前注册的属性值
         * */
        Yata.prototype.registerOnce = function (props, defaultValue, daysOrOptions) {
            var _this = this;
            var _a;
            var options = optionsForRegister(daysOrOptions);
            if (options.persistent) {
                (_a = this.persistence) === null || _a === void 0 ? void 0 : _a.registerOnce(props, defaultValue, options.days);
            }
            else {
                if (typeof defaultValue === 'undefined') {
                    defaultValue = 'None';
                }
                utils.each(props, function (val, prop) {
                    if (!_this.unpersisted_superprops.hasOwnProperty(prop) || _this.unpersisted_superprops[prop] === defaultValue) {
                        _this.unpersisted_superprops[prop] = val;
                    }
                });
            }
        };
        Yata.prototype.track = function (eventName, properties, options, callback) {
            var _a, _b, _c;
            if (!callback && typeof options === 'function') {
                callback = options;
                options = {};
            }
            options = options || {};
            var transport = options.transport;
            if (transport) {
                options.transport = transport;
            }
            var shouldSendImmediately = options.send_immediately;
            if (typeof callback !== 'function') {
                callback = NOOP_FUNC;
            }
            if (utils.isUndefined(eventName)) {
                console$1.error('No event name provided to yata.track');
                return;
            }
            if (this.eventIsDisabled(eventName)) {
                callback(0);
                return;
            }
            properties = properties || {};
            // TODO: need token?
            // properties.token = this.getConfig('token');
            properties.appid = this.getConfig('app_id');
            properties.appname = this.getConfig('app_name');
            var startTimestamp = (_a = this.persistence) === null || _a === void 0 ? void 0 : _a.removeEventTimer(eventName);
            if (!utils.isUndefined(startTimestamp)) {
                var durationInMS = utils.now() - startTimestamp;
                properties.millisecond = parseFloat((durationInMS / 1000).toFixed(3));
            }
            // 设置 searchKey、google系数及保存 Referrer
            this.setDefaultSuperProps();
            var $device_id = ((_b = this.persistence) === null || _b === void 0 ? void 0 : _b.properties()).$device_id;
            // 合并属性字段，手动上报时可在这里自定义采集指标
            properties = utils.extend({
                deviceid: $device_id
            }, Info.properties(), this.unpersisted_superprops, properties);
            // 做类型判断，不符合既定类型不上报
            // if (properties.eventtype && !utils.include(EVENT_TYPE, properties.eventtype)) {
            //   console.critical('Please check your eventtype: ' + properties.eventtype + ' is pre-set type of [' + EVENT_TYPE.join(',') + ']');
            //   return;
            // }
            // 将属性 block 黑名单中的从上报属性对象中剔除
            var propertyBlockList = this.getConfig('property_block_list');
            if (utils.isArray(propertyBlockList)) {
                utils.each(propertyBlockList, function (blockedProp) { return delete properties[blockedProp]; });
            }
            else {
                console$1.error('Invalid value for property_block_list config: ' + propertyBlockList);
            }
            var data = {
                event: eventName,
                properties: properties
            };
            var ret = this.trackOrBatch({
                type: 'events',
                data: data,
                endpoint: this.getConfig('api_host') + '/fds/qdcj/dc',
                batcher: (_c = this.request_batchers) === null || _c === void 0 ? void 0 : _c.events,
                should_send_immediately: !!shouldSendImmediately,
                send_request_options: options
            }, callback);
            this.checkAndHandleTriggeredNotification(data);
            return ret;
        };
        // 上报请求封装函数，核心函数为 sendRequest，根据是否已入列来返回 null/truncatedData
        Yata.prototype.trackOrBatch = function (options, callback) {
            var _this = this;
            var truncatedData = utils.truncate(options.data, 255); // 截取内容长度
            var endpoint = options.endpoint, batcher = options.batcher, should_send_immediately = options.should_send_immediately, send_request_options = options.send_request_options;
            callback = callback || NOOP_FUNC;
            var request_enqueued_or_initiated = true;
            // 立即发起上报请求操作
            var send_request_immediately = function () {
                // 需要钩子函数进行预处理时，对数据进行加工
                if (!(send_request_options === null || send_request_options === void 0 ? void 0 : send_request_options.skip_hooks)) {
                    truncatedData = _this.runHook('before_send_' + options.type, truncatedData);
                }
                if (truncatedData) {
                    // 立即上报时不是数组类型，需转换成数组处理
                    if (!utils.isArray(truncatedData)) {
                        truncatedData = [truncatedData];
                    }
                    console$1.log('YATA REQUEST:');
                    console$1.log(truncatedData);
                    return _this.sendRequest(endpoint, encodeDataForRequest(truncatedData), send_request_options, _this.prepareCallback(callback, truncatedData));
                }
                return null;
            };
            // 设置了批量请求且不立即发起上报时
            if (this._batch_requests && !should_send_immediately) {
                batcher === null || batcher === void 0 ? void 0 : batcher.enqueue(truncatedData, function (succeeded) {
                    if (succeeded) {
                        callback(1, truncatedData);
                    }
                    else {
                        send_request_immediately();
                    }
                });
            }
            else if (this.allow_upload) {
                request_enqueued_or_initiated = send_request_immediately();
            }
            return request_enqueued_or_initiated && truncatedData;
        };
        Yata.prototype.eventIsDisabled = function (eventName) {
            var _a;
            return utils.isBlockedUA(userAgent) || ((_a = this.flag) === null || _a === void 0 ? void 0 : _a.disable_all_events) || utils.include(this.__disabled_events, eventName);
        };
        Yata.prototype.setDefaultSuperProps = function () {
            var _a, _b, _c;
            (_a = this.persistence) === null || _a === void 0 ? void 0 : _a.updateSearchKeyword(doc.referrer);
            if (this.getConfig('store_google')) {
                (_b = this.persistence) === null || _b === void 0 ? void 0 : _b.updateCampaignParams();
            }
            if (this.getConfig('save_referrer')) {
                (_c = this.persistence) === null || _c === void 0 ? void 0 : _c.updateReferrerInfo(doc.referrer);
            }
        };
        // 针对 SDK 升级推送设计
        Yata.prototype.checkAndHandleTriggeredNotification = function (eventData) {
            if (!this.user_decide_check_complete) {
                this.events_tracked_before_user_decide_check_complete.push(eventData);
            }
        };
        return Yata;
    }());
    function createLogInstance() {
        MAIN_LOG = new Yata();
        return MAIN_LOG;
    }

    var yata = createLogInstance();

    return yata;

})));
